/*
	Copyright (c) 2004-2006, The Dojo Foundation
	All Rights Reserved.

	Licensed under the Academic Free License version 2.1 or above OR the
	modified BSD license. For more information on Dojo licensing, see:

		http://dojotoolkit.org/community/licensing.shtml
*/

/*
	This is a compiled version of Dojo, built for deployment and not for
	development. To get an editable version, please visit:

		http://dojotoolkit.org

	for documentation and information on getting the source.
*/

if(typeof dojo=="undefined"){
var dj_global=this;
var dj_currentContext=this;
function dj_undef(_1,_2){
return (typeof (_2||dj_currentContext)[_1]=="undefined");
}
if(dj_undef("djConfig",this)){
var djConfig={};
}
if(dj_undef("dojo",this)){
var dojo={};
}
dojo.global=function(){
return dj_currentContext;
};
dojo.locale=djConfig.locale;
dojo.version={major:0,minor:4,patch:0,flag:"",revision:Number("$Rev: 6258 $".match(/[0-9]+/)[0]),toString:function(){
with(dojo.version){
return major+"."+minor+"."+patch+flag+" ("+revision+")";
}
}};
dojo.evalProp=function(_3,_4,_5){
if((!_4)||(!_3)){
return undefined;
}
if(!dj_undef(_3,_4)){
return _4[_3];
}
return (_5?(_4[_3]={}):undefined);
};
dojo.parseObjPath=function(_6,_7,_8){
var _9=(_7||dojo.global());
var _a=_6.split(".");
var _b=_a.pop();
for(var i=0,l=_a.length;i<l&&_9;i++){
_9=dojo.evalProp(_a[i],_9,_8);
}
return {obj:_9,prop:_b};
};
dojo.evalObjPath=function(_e,_f){
if(typeof _e!="string"){
return dojo.global();
}
if(_e.indexOf(".")==-1){
return dojo.evalProp(_e,dojo.global(),_f);
}
var ref=dojo.parseObjPath(_e,dojo.global(),_f);
if(ref){
return dojo.evalProp(ref.prop,ref.obj,_f);
}
return null;
};
dojo.errorToString=function(_11){
if(!dj_undef("message",_11)){
return _11.message;
}else{
if(!dj_undef("description",_11)){
return _11.description;
}else{
return _11;
}
}
};
dojo.raise=function(_12,_13){
if(_13){
_12=_12+": "+dojo.errorToString(_13);
}
try{
if(djConfig.isDebug){
dojo.hostenv.println("FATAL exception raised: "+_12);
}
}
catch(e){
}
throw _13||Error(_12);
};
dojo.debug=function(){
};
dojo.debugShallow=function(obj){
};
dojo.profile={start:function(){
},end:function(){
},stop:function(){
},dump:function(){
}};
function dj_eval(_15){
return dj_global.eval?dj_global.eval(_15):eval(_15);
}
dojo.unimplemented=function(_16,_17){
var _18="'"+_16+"' not implemented";
if(_17!=null){
_18+=" "+_17;
}
dojo.raise(_18);
};
dojo.deprecated=function(_19,_1a,_1b){
var _1c="DEPRECATED: "+_19;
if(_1a){
_1c+=" "+_1a;
}
if(_1b){
_1c+=" -- will be removed in version: "+_1b;
}
dojo.debug(_1c);
};
dojo.render=(function(){
function vscaffold(_1d,_1e){
var tmp={capable:false,support:{builtin:false,plugin:false},prefixes:_1d};
for(var i=0;i<_1e.length;i++){
tmp[_1e[i]]=false;
}
return tmp;
}
return {name:"",ver:dojo.version,os:{win:false,linux:false,osx:false},html:vscaffold(["html"],["ie","opera","khtml","safari","moz"]),svg:vscaffold(["svg"],["corel","adobe","batik"]),vml:vscaffold(["vml"],["ie"]),swf:vscaffold(["Swf","Flash","Mm"],["mm"]),swt:vscaffold(["Swt"],["ibm"])};
})();
dojo.hostenv=(function(){
var _21={isDebug:false,allowQueryConfig:false,baseScriptUri:"",baseRelativePath:"",libraryScriptUri:"",iePreventClobber:false,ieClobberMinimal:true,preventBackButtonFix:true,delayMozLoadingFix:false,searchIds:[],parseWidgets:true};
if(typeof djConfig=="undefined"){
djConfig=_21;
}else{
for(var _22 in _21){
if(typeof djConfig[_22]=="undefined"){
djConfig[_22]=_21[_22];
}
}
}
return {name_:"(unset)",version_:"(unset)",getName:function(){
return this.name_;
},getVersion:function(){
return this.version_;
},getText:function(uri){
dojo.unimplemented("getText","uri="+uri);
}};
})();
dojo.hostenv.getBaseScriptUri=function(){
if(djConfig.baseScriptUri.length){
return djConfig.baseScriptUri;
}
var uri=new String(djConfig.libraryScriptUri||djConfig.baseRelativePath);
if(!uri){
dojo.raise("Nothing returned by getLibraryScriptUri(): "+uri);
}
var _25=uri.lastIndexOf("/");
djConfig.baseScriptUri=djConfig.baseRelativePath;
return djConfig.baseScriptUri;
};
(function(){
var _26={pkgFileName:"__package__",loading_modules_:{},loaded_modules_:{},addedToLoadingCount:[],removedFromLoadingCount:[],inFlightCount:0,modulePrefixes_:{dojo:{name:"dojo",value:"src"}},setModulePrefix:function(_27,_28){
this.modulePrefixes_[_27]={name:_27,value:_28};
},moduleHasPrefix:function(_29){
var mp=this.modulePrefixes_;
return Boolean(mp[_29]&&mp[_29].value);
},getModulePrefix:function(_2b){
if(this.moduleHasPrefix(_2b)){
return this.modulePrefixes_[_2b].value;
}
return _2b;
},getTextStack:[],loadUriStack:[],loadedUris:[],post_load_:false,modulesLoadedListeners:[],unloadListeners:[],loadNotifying:false};
for(var _2c in _26){
dojo.hostenv[_2c]=_26[_2c];
}
})();
dojo.hostenv.loadPath=function(_2d,_2e,cb){
var uri;
if(_2d.charAt(0)=="/"||_2d.match(/^\w+:/)){
uri=_2d;
}else{
uri=this.getBaseScriptUri()+_2d;
}
if(djConfig.cacheBust&&dojo.render.html.capable){
uri+="?"+String(djConfig.cacheBust).replace(/\W+/g,"");
}
try{
return !_2e?this.loadUri(uri,cb):this.loadUriAndCheck(uri,_2e,cb);
}
catch(e){
dojo.debug(e);
return false;
}
};
dojo.hostenv.loadUri=function(uri,cb){
if(this.loadedUris[uri]){
return true;
}
var _33=this.getText(uri,null,true);
if(!_33){
return false;
}
this.loadedUris[uri]=true;
if(cb){
_33="("+_33+")";
}
var _34=dj_eval(_33);
if(cb){
cb(_34);
}
return true;
};
dojo.hostenv.loadUriAndCheck=function(uri,_36,cb){
var ok=true;
try{
ok=this.loadUri(uri,cb);
}
catch(e){
dojo.debug("failed loading ",uri," with error: ",e);
}
return Boolean(ok&&this.findModule(_36,false));
};
dojo.loaded=function(){
};
dojo.unloaded=function(){
};
dojo.hostenv.loaded=function(){
this.loadNotifying=true;
this.post_load_=true;
var mll=this.modulesLoadedListeners;
for(var x=0;x<mll.length;x++){
mll[x]();
}
this.modulesLoadedListeners=[];
this.loadNotifying=false;
dojo.loaded();
};
dojo.hostenv.unloaded=function(){
var mll=this.unloadListeners;
while(mll.length){
(mll.pop())();
}
dojo.unloaded();
};
dojo.addOnLoad=function(obj,_3d){
var dh=dojo.hostenv;
if(arguments.length==1){
dh.modulesLoadedListeners.push(obj);
}else{
if(arguments.length>1){
dh.modulesLoadedListeners.push(function(){
obj[_3d]();
});
}
}
if(dh.post_load_&&dh.inFlightCount==0&&!dh.loadNotifying){
dh.callLoaded();
}
};
dojo.addOnUnload=function(obj,_40){
var dh=dojo.hostenv;
if(arguments.length==1){
dh.unloadListeners.push(obj);
}else{
if(arguments.length>1){
dh.unloadListeners.push(function(){
obj[_40]();
});
}
}
};
dojo.hostenv.modulesLoaded=function(){
if(this.post_load_){
return;
}
if(this.loadUriStack.length==0&&this.getTextStack.length==0){
if(this.inFlightCount>0){
dojo.debug("files still in flight!");
return;
}
dojo.hostenv.callLoaded();
}
};
dojo.hostenv.callLoaded=function(){
if(typeof setTimeout=="object"){
setTimeout("dojo.hostenv.loaded();",0);
}else{
dojo.hostenv.loaded();
}
};
dojo.hostenv.getModuleSymbols=function(_42){
var _43=_42.split(".");
for(var i=_43.length;i>0;i--){
var _45=_43.slice(0,i).join(".");
if((i==1)&&!this.moduleHasPrefix(_45)){
_43[0]="../"+_43[0];
}else{
var _46=this.getModulePrefix(_45);
if(_46!=_45){
_43.splice(0,i,_46);
break;
}
}
}
return _43;
};
dojo.hostenv._global_omit_module_check=false;
dojo.hostenv.loadModule=function(_47,_48,_49){
if(!_47){
return;
}
_49=this._global_omit_module_check||_49;
var _4a=this.findModule(_47,false);
if(_4a){
return _4a;
}
if(dj_undef(_47,this.loading_modules_)){
this.addedToLoadingCount.push(_47);
}
this.loading_modules_[_47]=1;
var _4b=_47.replace(/\./g,"/")+".js";
var _4c=_47.split(".");
var _4d=this.getModuleSymbols(_47);
var _4e=((_4d[0].charAt(0)!="/")&&!_4d[0].match(/^\w+:/));
var _4f=_4d[_4d.length-1];
var ok;
if(_4f=="*"){
_47=_4c.slice(0,-1).join(".");
while(_4d.length){
_4d.pop();
_4d.push(this.pkgFileName);
_4b=_4d.join("/")+".js";
if(_4e&&_4b.charAt(0)=="/"){
_4b=_4b.slice(1);
}
ok=this.loadPath(_4b,!_49?_47:null);
if(ok){
break;
}
_4d.pop();
}
}else{
_4b=_4d.join("/")+".js";
_47=_4c.join(".");
var _51=!_49?_47:null;
ok=this.loadPath(_4b,_51);
if(!ok&&!_48){
_4d.pop();
while(_4d.length){
_4b=_4d.join("/")+".js";
ok=this.loadPath(_4b,_51);
if(ok){
break;
}
_4d.pop();
_4b=_4d.join("/")+"/"+this.pkgFileName+".js";
if(_4e&&_4b.charAt(0)=="/"){
_4b=_4b.slice(1);
}
ok=this.loadPath(_4b,_51);
if(ok){
break;
}
}
}
if(!ok&&!_49){
dojo.raise("Could not load '"+_47+"'; last tried '"+_4b+"'");
}
}
if(!_49&&!this["isXDomain"]){
_4a=this.findModule(_47,false);
if(!_4a){
dojo.raise("symbol '"+_47+"' is not defined after loading '"+_4b+"'");
}
}
return _4a;
};
dojo.hostenv.startPackage=function(_52){
var _53=String(_52);
var _54=_53;
var _55=_52.split(/\./);
if(_55[_55.length-1]=="*"){
_55.pop();
_54=_55.join(".");
}
var _56=dojo.evalObjPath(_54,true);
this.loaded_modules_[_53]=_56;
this.loaded_modules_[_54]=_56;
return _56;
};
dojo.hostenv.findModule=function(_57,_58){
var lmn=String(_57);
if(this.loaded_modules_[lmn]){
return this.loaded_modules_[lmn];
}
if(_58){
dojo.raise("no loaded module named '"+_57+"'");
}
return null;
};
dojo.kwCompoundRequire=function(_5a){
var _5b=_5a["common"]||[];
var _5c=_5a[dojo.hostenv.name_]?_5b.concat(_5a[dojo.hostenv.name_]||[]):_5b.concat(_5a["default"]||[]);
for(var x=0;x<_5c.length;x++){
var _5e=_5c[x];
if(_5e.constructor==Array){
dojo.hostenv.loadModule.apply(dojo.hostenv,_5e);
}else{
dojo.hostenv.loadModule(_5e);
}
}
};
dojo.require=function(_5f){
dojo.hostenv.loadModule.apply(dojo.hostenv,arguments);
};
dojo.requireIf=function(_60,_61){
var _62=arguments[0];
if((_62===true)||(_62=="common")||(_62&&dojo.render[_62].capable)){
var _63=[];
for(var i=1;i<arguments.length;i++){
_63.push(arguments[i]);
}
dojo.require.apply(dojo,_63);
}
};
dojo.requireAfterIf=dojo.requireIf;
dojo.provide=function(_65){
return dojo.hostenv.startPackage.apply(dojo.hostenv,arguments);
};
dojo.registerModulePath=function(_66,_67){
return dojo.hostenv.setModulePrefix(_66,_67);
};
dojo.setModulePrefix=function(_68,_69){
dojo.deprecated("dojo.setModulePrefix(\""+_68+"\", \""+_69+"\")","replaced by dojo.registerModulePath","0.5");
return dojo.registerModulePath(_68,_69);
};
dojo.exists=function(obj,_6b){
var p=_6b.split(".");
for(var i=0;i<p.length;i++){
if(!obj[p[i]]){
return false;
}
obj=obj[p[i]];
}
return true;
};
dojo.hostenv.normalizeLocale=function(_6e){
return _6e?_6e.toLowerCase():dojo.locale;
};
dojo.hostenv.searchLocalePath=function(_6f,_70,_71){
_6f=dojo.hostenv.normalizeLocale(_6f);
var _72=_6f.split("-");
var _73=[];
for(var i=_72.length;i>0;i--){
_73.push(_72.slice(0,i).join("-"));
}
_73.push(false);
if(_70){
_73.reverse();
}
for(var j=_73.length-1;j>=0;j--){
var loc=_73[j]||"ROOT";
var _77=_71(loc);
if(_77){
break;
}
}
};
dojo.hostenv.localesGenerated;
dojo.hostenv.registerNlsPrefix=function(){
dojo.registerModulePath("nls","nls");
};
dojo.hostenv.preloadLocalizations=function(){
if(dojo.hostenv.localesGenerated){
dojo.hostenv.registerNlsPrefix();
function preload(_78){
_78=dojo.hostenv.normalizeLocale(_78);
dojo.hostenv.searchLocalePath(_78,true,function(loc){
for(var i=0;i<dojo.hostenv.localesGenerated.length;i++){
if(dojo.hostenv.localesGenerated[i]==loc){
dojo["require"]("nls.dojo_"+loc);
return true;
}
}
return false;
});
}
preload();
var _7b=djConfig.extraLocale||[];
for(var i=0;i<_7b.length;i++){
preload(_7b[i]);
}
}
dojo.hostenv.preloadLocalizations=function(){
};
};
dojo.requireLocalization=function(_7d,_7e,_7f){
dojo.hostenv.preloadLocalizations();
var _80=[_7d,"nls",_7e].join(".");
var _81=dojo.hostenv.findModule(_80);
if(_81){
if(djConfig.localizationComplete&&_81._built){
return;
}
var _82=dojo.hostenv.normalizeLocale(_7f).replace("-","_");
var _83=_80+"."+_82;
if(dojo.hostenv.findModule(_83)){
return;
}
}
_81=dojo.hostenv.startPackage(_80);
var _84=dojo.hostenv.getModuleSymbols(_7d);
var _85=_84.concat("nls").join("/");
var _86;
dojo.hostenv.searchLocalePath(_7f,false,function(loc){
var _88=loc.replace("-","_");
var _89=_80+"."+_88;
var _8a=false;
if(!dojo.hostenv.findModule(_89)){
dojo.hostenv.startPackage(_89);
var _8b=[_85];
if(loc!="ROOT"){
_8b.push(loc);
}
_8b.push(_7e);
var _8c=_8b.join("/")+".js";
_8a=dojo.hostenv.loadPath(_8c,null,function(_8d){
var _8e=function(){
};
_8e.prototype=_86;
_81[_88]=new _8e();
for(var j in _8d){
_81[_88][j]=_8d[j];
}
});
}else{
_8a=true;
}
if(_8a&&_81[_88]){
_86=_81[_88];
}else{
_81[_88]=_86;
}
});
};
(function(){
var _90=djConfig.extraLocale;
if(_90){
if(!_90 instanceof Array){
_90=[_90];
}
var req=dojo.requireLocalization;
dojo.requireLocalization=function(m,b,_94){
req(m,b,_94);
if(_94){
return;
}
for(var i=0;i<_90.length;i++){
req(m,b,_90[i]);
}
};
}
})();
}
if(typeof window!="undefined"){
(function(){
if(djConfig.allowQueryConfig){
var _96=document.location.toString();
var _97=_96.split("?",2);
if(_97.length>1){
var _98=_97[1];
var _99=_98.split("&");
for(var x in _99){
var sp=_99[x].split("=");
if((sp[0].length>9)&&(sp[0].substr(0,9)=="djConfig.")){
var opt=sp[0].substr(9);
try{
djConfig[opt]=eval(sp[1]);
}
catch(e){
djConfig[opt]=sp[1];
}
}
}
}
}
if(((djConfig["baseScriptUri"]=="")||(djConfig["baseRelativePath"]==""))&&(document&&document.getElementsByTagName)){
var _9d=document.getElementsByTagName("script");
var _9e=/(__package__|dojo|bootstrap1)\.js([\?\.]|$)/i;
for(var i=0;i<_9d.length;i++){
var src=_9d[i].getAttribute("src");
if(!src){
continue;
}
var m=src.match(_9e);
if(m){
var _a2=src.substring(0,m.index);
if(src.indexOf("bootstrap1")>-1){
_a2+="../";
}
if(!this["djConfig"]){
djConfig={};
}
if(djConfig["baseScriptUri"]==""){
djConfig["baseScriptUri"]=_a2;
}
if(djConfig["baseRelativePath"]==""){
djConfig["baseRelativePath"]=_a2;
}
break;
}
}
}
var dr=dojo.render;
var drh=dojo.render.html;
var drs=dojo.render.svg;
var dua=(drh.UA=navigator.userAgent);
var dav=(drh.AV=navigator.appVersion);
var t=true;
var f=false;
drh.capable=t;
drh.support.builtin=t;
dr.ver=parseFloat(drh.AV);
dr.os.mac=dav.indexOf("Macintosh")>=0;
dr.os.win=dav.indexOf("Windows")>=0;
dr.os.linux=dav.indexOf("X11")>=0;
drh.opera=dua.indexOf("Opera")>=0;
drh.khtml=(dav.indexOf("Konqueror")>=0)||(dav.indexOf("Safari")>=0);
drh.safari=dav.indexOf("Safari")>=0;
var _aa=dua.indexOf("Gecko");
drh.mozilla=drh.moz=(_aa>=0)&&(!drh.khtml);
if(drh.mozilla){
drh.geckoVersion=dua.substring(_aa+6,_aa+14);
}
drh.ie=(document.all)&&(!drh.opera);
drh.ie50=drh.ie&&dav.indexOf("MSIE 5.0")>=0;
drh.ie55=drh.ie&&dav.indexOf("MSIE 5.5")>=0;
drh.ie60=drh.ie&&dav.indexOf("MSIE 6.0")>=0;
drh.ie70=drh.ie&&dav.indexOf("MSIE 7.0")>=0;
var cm=document["compatMode"];
drh.quirks=(cm=="BackCompat")||(cm=="QuirksMode")||drh.ie55||drh.ie50;
dojo.locale=dojo.locale||(drh.ie?navigator.userLanguage:navigator.language).toLowerCase();
dr.vml.capable=drh.ie;
drs.capable=f;
drs.support.plugin=f;
drs.support.builtin=f;
var _ac=window["document"];
var tdi=_ac["implementation"];
if((tdi)&&(tdi["hasFeature"])&&(tdi.hasFeature("org.w3c.dom.svg","1.0"))){
drs.capable=t;
drs.support.builtin=t;
drs.support.plugin=f;
}
if(drh.safari){
var tmp=dua.split("AppleWebKit/")[1];
var ver=parseFloat(tmp.split(" ")[0]);
if(ver>=420){
drs.capable=t;
drs.support.builtin=t;
drs.support.plugin=f;
}
}
})();
dojo.hostenv.startPackage("dojo.hostenv");
dojo.render.name=dojo.hostenv.name_="browser";
dojo.hostenv.searchIds=[];
dojo.hostenv._XMLHTTP_PROGIDS=["Msxml2.XMLHTTP","Microsoft.XMLHTTP","Msxml2.XMLHTTP.4.0"];
dojo.hostenv.getXmlhttpObject=function(){
var _b0=null;
var _b1=null;
try{
_b0=new XMLHttpRequest();
}
catch(e){
}
if(!_b0){
for(var i=0;i<3;++i){
var _b3=dojo.hostenv._XMLHTTP_PROGIDS[i];
try{
_b0=new ActiveXObject(_b3);
}
catch(e){
_b1=e;
}
if(_b0){
dojo.hostenv._XMLHTTP_PROGIDS=[_b3];
break;
}
}
}
if(!_b0){
return dojo.raise("XMLHTTP not available",_b1);
}
return _b0;
};
dojo.hostenv._blockAsync=false;
dojo.hostenv.getText=function(uri,_b5,_b6){
if(!_b5){
this._blockAsync=true;
}
var _b7=this.getXmlhttpObject();
function isDocumentOk(_b8){
var _b9=_b8["status"];
return Boolean((!_b9)||((200<=_b9)&&(300>_b9))||(_b9==304));
}
if(_b5){
var _ba=this,_bb=null,gbl=dojo.global();
var xhr=dojo.evalObjPath("dojo.io.XMLHTTPTransport");
_b7.onreadystatechange=function(){
if(_bb){
gbl.clearTimeout(_bb);
_bb=null;
}
if(_ba._blockAsync||(xhr&&xhr._blockAsync)){
_bb=gbl.setTimeout(function(){
_b7.onreadystatechange.apply(this);
},10);
}else{
if(4==_b7.readyState){
if(isDocumentOk(_b7)){
_b5(_b7.responseText);
}
}
}
};
}
_b7.open("GET",uri,_b5?true:false);
try{
_b7.send(null);
if(_b5){
return null;
}
if(!isDocumentOk(_b7)){
var err=Error("Unable to load "+uri+" status:"+_b7.status);
err.status=_b7.status;
err.responseText=_b7.responseText;
throw err;
}
}
catch(e){
this._blockAsync=false;
if((_b6)&&(!_b5)){
return null;
}else{
throw e;
}
}
this._blockAsync=false;
return _b7.responseText;
};
dojo.hostenv.defaultDebugContainerId="dojoDebug";
dojo.hostenv._println_buffer=[];
dojo.hostenv._println_safe=false;
dojo.hostenv.println=function(_bf){
if(!dojo.hostenv._println_safe){
dojo.hostenv._println_buffer.push(_bf);
}else{
try{
var _c0=document.getElementById(djConfig.debugContainerId?djConfig.debugContainerId:dojo.hostenv.defaultDebugContainerId);
if(!_c0){
_c0=dojo.body();
}
var div=document.createElement("div");
div.appendChild(document.createTextNode(_bf));
_c0.appendChild(div);
}
catch(e){
try{
document.write("<div>"+_bf+"</div>");
}
catch(e2){
window.status=_bf;
}
}
}
};
dojo.addOnLoad(function(){
dojo.hostenv._println_safe=true;
while(dojo.hostenv._println_buffer.length>0){
dojo.hostenv.println(dojo.hostenv._println_buffer.shift());
}
});
function dj_addNodeEvtHdlr(_c2,_c3,fp,_c5){
var _c6=_c2["on"+_c3]||function(){
};
_c2["on"+_c3]=function(){
fp.apply(_c2,arguments);
_c6.apply(_c2,arguments);
};
return true;
}
function dj_load_init(e){
var _c8=(e&&e.type)?e.type.toLowerCase():"load";
if(arguments.callee.initialized||(_c8!="domcontentloaded"&&_c8!="load")){
return;
}
arguments.callee.initialized=true;
if(typeof (_timer)!="undefined"){
clearInterval(_timer);
delete _timer;
}
var _c9=function(){
if(dojo.render.html.ie){
dojo.hostenv.makeWidgets();
}
};
if(dojo.hostenv.inFlightCount==0){
_c9();
dojo.hostenv.modulesLoaded();
}else{
dojo.addOnLoad(_c9);
}
}
if(document.addEventListener){
if(dojo.render.html.opera||(dojo.render.html.moz&&!djConfig.delayMozLoadingFix)){
document.addEventListener("DOMContentLoaded",dj_load_init,null);
}
window.addEventListener("load",dj_load_init,null);
}
if(dojo.render.html.ie&&dojo.render.os.win){
document.attachEvent("onreadystatechange",function(e){
if(document.readyState=="complete"){
dj_load_init();
}
});
}
if(/(WebKit|khtml)/i.test(navigator.userAgent)){
var _timer=setInterval(function(){
if(/loaded|complete/.test(document.readyState)){
dj_load_init();
}
},10);
}
if(dojo.render.html.ie){
dj_addNodeEvtHdlr(window,"beforeunload",function(){
dojo.hostenv._unloading=true;
window.setTimeout(function(){
dojo.hostenv._unloading=false;
},0);
});
}
dj_addNodeEvtHdlr(window,"unload",function(){
dojo.hostenv.unloaded();
if((!dojo.render.html.ie)||(dojo.render.html.ie&&dojo.hostenv._unloading)){
dojo.hostenv.unloaded();
}
});
dojo.hostenv.makeWidgets=function(){
var _cb=[];
if(djConfig.searchIds&&djConfig.searchIds.length>0){
_cb=_cb.concat(djConfig.searchIds);
}
if(dojo.hostenv.searchIds&&dojo.hostenv.searchIds.length>0){
_cb=_cb.concat(dojo.hostenv.searchIds);
}
if((djConfig.parseWidgets)||(_cb.length>0)){
if(dojo.evalObjPath("dojo.widget.Parse")){
var _cc=new dojo.xml.Parse();
if(_cb.length>0){
for(var x=0;x<_cb.length;x++){
var _ce=document.getElementById(_cb[x]);
if(!_ce){
continue;
}
var _cf=_cc.parseElement(_ce,null,true);
dojo.widget.getParser().createComponents(_cf);
}
}else{
if(djConfig.parseWidgets){
var _cf=_cc.parseElement(dojo.body(),null,true);
dojo.widget.getParser().createComponents(_cf);
}
}
}
}
};
dojo.addOnLoad(function(){
if(!dojo.render.html.ie){
dojo.hostenv.makeWidgets();
}
});
try{
if(dojo.render.html.ie){
document.namespaces.add("v","urn:schemas-microsoft-com:vml");
document.createStyleSheet().addRule("v\\:*","behavior:url(#default#VML)");
}
}
catch(e){
}
dojo.hostenv.writeIncludes=function(){
};
if(!dj_undef("document",this)){
dj_currentDocument=this.document;
}
dojo.doc=function(){
return dj_currentDocument;
};
dojo.body=function(){
return dojo.doc().body||dojo.doc().getElementsByTagName("body")[0];
};
dojo.byId=function(id,doc){
if((id)&&((typeof id=="string")||(id instanceof String))){
if(!doc){
doc=dj_currentDocument;
}
var ele=doc.getElementById(id);
if(ele&&(ele.id!=id)&&doc.all){
ele=null;
eles=doc.all[id];
if(eles){
if(eles.length){
for(var i=0;i<eles.length;i++){
if(eles[i].id==id){
ele=eles[i];
break;
}
}
}else{
ele=eles;
}
}
}
return ele;
}
return id;
};
dojo.setContext=function(_d4,_d5){
dj_currentContext=_d4;
dj_currentDocument=_d5;
};
dojo._fireCallback=function(_d6,_d7,_d8){
if((_d7)&&((typeof _d6=="string")||(_d6 instanceof String))){
_d6=_d7[_d6];
}
return (_d7?_d6.apply(_d7,_d8||[]):_d6());
};
dojo.withGlobal=function(_d9,_da,_db,_dc){
var _dd;
var _de=dj_currentContext;
var _df=dj_currentDocument;
try{
dojo.setContext(_d9,_d9.document);
_dd=dojo._fireCallback(_da,_db,_dc);
}
finally{
dojo.setContext(_de,_df);
}
return _dd;
};
dojo.withDoc=function(_e0,_e1,_e2,_e3){
var _e4;
var _e5=dj_currentDocument;
try{
dj_currentDocument=_e0;
_e4=dojo._fireCallback(_e1,_e2,_e3);
}
finally{
dj_currentDocument=_e5;
}
return _e4;
};
}
dojo.render.name=dojo.hostenv.name_="dashboard";
dojo.hostenv.println=function(_e6){
return alert(_e6);
};
dojo.hostenv.getXmlhttpObject=function(_e7){
if(widget.system&&_e7){
if((_e7.contentType&&_e7.contentType.indexOf("text/")!=0)||(_e7.headers&&_e7.headers["content-type"]&&_e7.headers["content-type"].indexOf("text/")!=0)){
var _e8=new dojo.hostenv.CurlRequest;
_e8._save=true;
return _e8;
}else{
if(_e7.method&&_e7.method.toUpperCase()=="HEAD"){
return new dojo.hostenv.CurlRequest;
}else{
if(_e7.headers&&_e7.header.referer){
return new dojo.hostenv.CurlRequest;
}
}
}
}
return new XMLHttpRequest;
};
dojo.hostenv.CurlRequest=function(){
this.onreadystatechange=null;
this.readyState=0;
this.responseText="";
this.responseXML=null;
this.status=0;
this.statusText="";
this._method="";
this._url="";
this._async=true;
this._referrer="";
this._headers=[];
this._save=false;
this._responseHeader="";
this._responseHeaders={};
this._fileName="";
this._username="";
this._password="";
};
dojo.hostenv.CurlRequest.prototype.open=function(_e9,url,_eb,_ec,_ed){
this._method=_e9;
this._url=url;
if(_eb){
this._async=_eb;
}
if(_ec){
this._username=_ec;
}
if(_ed){
this._password=_ed;
}
};
dojo.hostenv.CurlRequest.prototype.setRequestHeader=function(_ee,_ef){
switch(_ee){
case "Referer":
this._referrer=_ef;
break;
case "content-type":
break;
default:
this._headers.push(_ee+"="+_ef);
break;
}
};
dojo.hostenv.CurlRequest.prototype.getAllResponseHeaders=function(){
return this._responseHeader;
};
dojo.hostenv.CurlRequest.prototype.getResponseHeader=function(_f0){
return this._responseHeaders[_f0];
};
dojo.hostenv.CurlRequest.prototype.send=function(_f1){
this.readyState=1;
if(this.onreadystatechange){
this.onreadystatechange.call(this);
}
var _f2={sS:""};
if(this._referrer){
_f2.e=this._referrer;
}
if(this._headers.length){
_f2.H=this._headers.join("&");
}
if(this._username){
if(this._password){
_f2.u=this._username+":"+this._password;
}else{
_f2.u=this._username;
}
}
if(_f1){
_f2.d=this.content;
if(this._method!="POST"){
_f2.G="";
}
}
if(this._method=="HEAD"){
_f2.I="";
}else{
if(this._save){
_f2.I="";
}else{
_f2.i="";
}
}
var _f3=widget.system(dojo.hostenv.CurlRequest._formatCall(_f2,this._url),null);
this.readyState=2;
if(this.onreadystatechange){
this.onreadystatechange.call(this);
}
if(_f3.errorString){
this.responseText=_f3.errorString;
this.status=0;
}else{
if(this._save){
this._responseHeader=_f3.outputString;
}else{
var _f4=_f3.outputString.replace(/\r/g,"").split("\n\n",2);
this._responseHeader=_f4[0];
this.responseText=_f4[1];
}
_f4=this._responseHeader.split("\n");
this.statusText=_f4.shift();
this.status=this.statusText.split(" ")[1];
for(var i=0,_f6;_f6=_f4[i];i++){
var _f7=_f6.split(": ",2);
this._responseHeaders[_f7[0]]=_f7[1];
}
if(this._save){
widget.system("/bin/mkdir cache",null);
this._fileName=this._url.split("/").pop().replace(/\W/g,"");
this._fileName+="."+this._responseHeaders["Content-Type"].replace(/[\r\n]/g,"").split("/").pop();
delete _f2.I;
_f2.o="cache/"+this._fileName;
_f3=widget.system(dojo.hostenv.CurlRequest._formatCall(_f2,this._url),null);
if(!_f3.errorString){
this.responseText="cache/"+this._fileName;
}
}else{
if(this._method=="HEAD"){
this.responseText=this._responseHeader;
}
}
}
this.readyState=4;
if(this.onreadystatechange){
this.onreadystatechange.call(this);
}
};
dojo.hostenv.CurlRequest._formatCall=function(_f8,url){
var _fa=["/usr/bin/curl"];
for(var key in _f8){
if(_f8[key]!=""){
_fa.push("-"+key+" '"+_f8[key].replace(/'/g,"'")+"'");
}else{
_fa.push("-"+key);
}
}
_fa.push("'"+url.replace(/'/g,"'")+"'");
return _fa.join(" ");
};
dojo.hostenv.exit=function(){
if(widget.system){
widget.system("/bin/rm -rf cache/*",null);
}
};
(function(){
if(typeof dj_usingBootstrap!="undefined"){
return;
}
var _fc=false;
var _fd=false;
var _fe=false;
if((typeof this["load"]=="function")&&((typeof this["Packages"]=="function")||(typeof this["Packages"]=="object"))){
_fc=true;
}else{
if(typeof this["load"]=="function"){
_fd=true;
}else{
if(window.widget){
_fe=true;
}
}
}
var _ff=[];
if((this["djConfig"])&&((djConfig["isDebug"])||(djConfig["debugAtAllCosts"]))){
_ff.push("debug.js");
}
if((this["djConfig"])&&(djConfig["debugAtAllCosts"])&&(!_fc)&&(!_fe)){
_ff.push("browser_debug.js");
}
var _100=djConfig["baseScriptUri"];
if((this["djConfig"])&&(djConfig["baseLoaderUri"])){
_100=djConfig["baseLoaderUri"];
}
for(var x=0;x<_ff.length;x++){
var _102=_100+"src/"+_ff[x];
if(_fc||_fd){
load(_102);
}else{
try{
document.write("<scr"+"ipt type='text/javascript' src='"+_102+"'></scr"+"ipt>");
}
catch(e){
var _103=document.createElement("script");
_103.src=_102;
document.getElementsByTagName("head")[0].appendChild(_103);
}
}
}
})();
dojo.provide("dojo.lang.common");
dojo.lang.inherits=function(_104,_105){
if(typeof _105!="function"){
dojo.raise("dojo.inherits: superclass argument ["+_105+"] must be a function (subclass: ["+_104+"']");
}
_104.prototype=new _105();
_104.prototype.constructor=_104;
_104.superclass=_105.prototype;
_104["super"]=_105.prototype;
};
dojo.lang._mixin=function(obj,_107){
var tobj={};
for(var x in _107){
if((typeof tobj[x]=="undefined")||(tobj[x]!=_107[x])){
obj[x]=_107[x];
}
}
if(dojo.render.html.ie&&(typeof (_107["toString"])=="function")&&(_107["toString"]!=obj["toString"])&&(_107["toString"]!=tobj["toString"])){
obj.toString=_107.toString;
}
return obj;
};
dojo.lang.mixin=function(obj,_10b){
for(var i=1,l=arguments.length;i<l;i++){
dojo.lang._mixin(obj,arguments[i]);
}
return obj;
};
dojo.lang.extend=function(_10e,_10f){
for(var i=1,l=arguments.length;i<l;i++){
dojo.lang._mixin(_10e.prototype,arguments[i]);
}
return _10e;
};
dojo.inherits=dojo.lang.inherits;
dojo.mixin=dojo.lang.mixin;
dojo.extend=dojo.lang.extend;
dojo.lang.find=function(_112,_113,_114,_115){
if(!dojo.lang.isArrayLike(_112)&&dojo.lang.isArrayLike(_113)){
dojo.deprecated("dojo.lang.find(value, array)","use dojo.lang.find(array, value) instead","0.5");
var temp=_112;
_112=_113;
_113=temp;
}
var _117=dojo.lang.isString(_112);
if(_117){
_112=_112.split("");
}
if(_115){
var step=-1;
var i=_112.length-1;
var end=-1;
}else{
var step=1;
var i=0;
var end=_112.length;
}
if(_114){
while(i!=end){
if(_112[i]===_113){
return i;
}
i+=step;
}
}else{
while(i!=end){
if(_112[i]==_113){
return i;
}
i+=step;
}
}
return -1;
};
dojo.lang.indexOf=dojo.lang.find;
dojo.lang.findLast=function(_11b,_11c,_11d){
return dojo.lang.find(_11b,_11c,_11d,true);
};
dojo.lang.lastIndexOf=dojo.lang.findLast;
dojo.lang.inArray=function(_11e,_11f){
return dojo.lang.find(_11e,_11f)>-1;
};
dojo.lang.isObject=function(it){
if(typeof it=="undefined"){
return false;
}
return (typeof it=="object"||it===null||dojo.lang.isArray(it)||dojo.lang.isFunction(it));
};
dojo.lang.isArray=function(it){
return (it&&it instanceof Array||typeof it=="array");
};
dojo.lang.isArrayLike=function(it){
if((!it)||(dojo.lang.isUndefined(it))){
return false;
}
if(dojo.lang.isString(it)){
return false;
}
if(dojo.lang.isFunction(it)){
return false;
}
if(dojo.lang.isArray(it)){
return true;
}
if((it.tagName)&&(it.tagName.toLowerCase()=="form")){
return false;
}
if(dojo.lang.isNumber(it.length)&&isFinite(it.length)){
return true;
}
return false;
};
dojo.lang.isFunction=function(it){
if(!it){
return false;
}
if((typeof (it)=="function")&&(it=="[object NodeList]")){
return false;
}
return (it instanceof Function||typeof it=="function");
};
dojo.lang.isString=function(it){
return (typeof it=="string"||it instanceof String);
};
dojo.lang.isAlien=function(it){
if(!it){
return false;
}
return !dojo.lang.isFunction()&&/\{\s*\[native code\]\s*\}/.test(String(it));
};
dojo.lang.isBoolean=function(it){
return (it instanceof Boolean||typeof it=="boolean");
};
dojo.lang.isNumber=function(it){
return (it instanceof Number||typeof it=="number");
};
dojo.lang.isUndefined=function(it){
return ((typeof (it)=="undefined")&&(it==undefined));
};
dojo.provide("dojo.lang");
dojo.deprecated("dojo.lang","replaced by dojo.lang.common","0.5");
dojo.provide("dojo.lang.array");
dojo.lang.has=function(obj,name){
try{
return typeof obj[name]!="undefined";
}
catch(e){
return false;
}
};
dojo.lang.isEmpty=function(obj){
if(dojo.lang.isObject(obj)){
var tmp={};
var _12d=0;
for(var x in obj){
if(obj[x]&&(!tmp[x])){
_12d++;
break;
}
}
return _12d==0;
}else{
if(dojo.lang.isArrayLike(obj)||dojo.lang.isString(obj)){
return obj.length==0;
}
}
};
dojo.lang.map=function(arr,obj,_131){
var _132=dojo.lang.isString(arr);
if(_132){
arr=arr.split("");
}
if(dojo.lang.isFunction(obj)&&(!_131)){
_131=obj;
obj=dj_global;
}else{
if(dojo.lang.isFunction(obj)&&_131){
var _133=obj;
obj=_131;
_131=_133;
}
}
if(Array.map){
var _134=Array.map(arr,_131,obj);
}else{
var _134=[];
for(var i=0;i<arr.length;++i){
_134.push(_131.call(obj,arr[i]));
}
}
if(_132){
return _134.join("");
}else{
return _134;
}
};
dojo.lang.reduce=function(arr,_137,obj,_139){
var _13a=_137;
var ob=obj?obj:dj_global;
dojo.lang.map(arr,function(val){
_13a=_139.call(ob,_13a,val);
});
return _13a;
};
dojo.lang.forEach=function(_13d,_13e,_13f){
if(dojo.lang.isString(_13d)){
_13d=_13d.split("");
}
if(Array.forEach){
Array.forEach(_13d,_13e,_13f);
}else{
if(!_13f){
_13f=dj_global;
}
for(var i=0,l=_13d.length;i<l;i++){
_13e.call(_13f,_13d[i],i,_13d);
}
}
};
dojo.lang._everyOrSome=function(_142,arr,_144,_145){
if(dojo.lang.isString(arr)){
arr=arr.split("");
}
if(Array.every){
return Array[_142?"every":"some"](arr,_144,_145);
}else{
if(!_145){
_145=dj_global;
}
for(var i=0,l=arr.length;i<l;i++){
var _148=_144.call(_145,arr[i],i,arr);
if(_142&&!_148){
return false;
}else{
if((!_142)&&(_148)){
return true;
}
}
}
return Boolean(_142);
}
};
dojo.lang.every=function(arr,_14a,_14b){
return this._everyOrSome(true,arr,_14a,_14b);
};
dojo.lang.some=function(arr,_14d,_14e){
return this._everyOrSome(false,arr,_14d,_14e);
};
dojo.lang.filter=function(arr,_150,_151){
var _152=dojo.lang.isString(arr);
if(_152){
arr=arr.split("");
}
var _153;
if(Array.filter){
_153=Array.filter(arr,_150,_151);
}else{
if(!_151){
if(arguments.length>=3){
dojo.raise("thisObject doesn't exist!");
}
_151=dj_global;
}
_153=[];
for(var i=0;i<arr.length;i++){
if(_150.call(_151,arr[i],i,arr)){
_153.push(arr[i]);
}
}
}
if(_152){
return _153.join("");
}else{
return _153;
}
};
dojo.lang.unnest=function(){
var out=[];
for(var i=0;i<arguments.length;i++){
if(dojo.lang.isArrayLike(arguments[i])){
var add=dojo.lang.unnest.apply(this,arguments[i]);
out=out.concat(add);
}else{
out.push(arguments[i]);
}
}
return out;
};
dojo.lang.toArray=function(_158,_159){
var _15a=[];
for(var i=_159||0;i<_158.length;i++){
_15a.push(_158[i]);
}
return _15a;
};
dojo.provide("dojo.lang.extras");
dojo.lang.setTimeout=function(func,_15d){
var _15e=window,_15f=2;
if(!dojo.lang.isFunction(func)){
_15e=func;
func=_15d;
_15d=arguments[2];
_15f++;
}
if(dojo.lang.isString(func)){
func=_15e[func];
}
var args=[];
for(var i=_15f;i<arguments.length;i++){
args.push(arguments[i]);
}
return dojo.global().setTimeout(function(){
func.apply(_15e,args);
},_15d);
};
dojo.lang.clearTimeout=function(_162){
dojo.global().clearTimeout(_162);
};
dojo.lang.getNameInObj=function(ns,item){
if(!ns){
ns=dj_global;
}
for(var x in ns){
if(ns[x]===item){
return new String(x);
}
}
return null;
};
dojo.lang.shallowCopy=function(obj,deep){
var i,ret;
if(obj===null){
return null;
}
if(dojo.lang.isObject(obj)){
ret=new obj.constructor();
for(i in obj){
if(dojo.lang.isUndefined(ret[i])){
ret[i]=deep?dojo.lang.shallowCopy(obj[i],deep):obj[i];
}
}
}else{
if(dojo.lang.isArray(obj)){
ret=[];
for(i=0;i<obj.length;i++){
ret[i]=deep?dojo.lang.shallowCopy(obj[i],deep):obj[i];
}
}else{
ret=obj;
}
}
return ret;
};
dojo.lang.firstValued=function(){
for(var i=0;i<arguments.length;i++){
if(typeof arguments[i]!="undefined"){
return arguments[i];
}
}
return undefined;
};
dojo.lang.getObjPathValue=function(_16b,_16c,_16d){
with(dojo.parseObjPath(_16b,_16c,_16d)){
return dojo.evalProp(prop,obj,_16d);
}
};
dojo.lang.setObjPathValue=function(_16e,_16f,_170,_171){
if(arguments.length<4){
_171=true;
}
with(dojo.parseObjPath(_16e,_170,_171)){
if(obj&&(_171||(prop in obj))){
obj[prop]=_16f;
}
}
};
dojo.provide("dojo.lang.func");
dojo.lang.hitch=function(_172,_173){
var fcn=(dojo.lang.isString(_173)?_172[_173]:_173)||function(){
};
return function(){
return fcn.apply(_172,arguments);
};
};
dojo.lang.anonCtr=0;
dojo.lang.anon={};
dojo.lang.nameAnonFunc=function(_175,_176,_177){
var nso=(_176||dojo.lang.anon);
if((_177)||((dj_global["djConfig"])&&(djConfig["slowAnonFuncLookups"]==true))){
for(var x in nso){
try{
if(nso[x]===_175){
return x;
}
}
catch(e){
}
}
}
var ret="__"+dojo.lang.anonCtr++;
while(typeof nso[ret]!="undefined"){
ret="__"+dojo.lang.anonCtr++;
}
nso[ret]=_175;
return ret;
};
dojo.lang.forward=function(_17b){
return function(){
return this[_17b].apply(this,arguments);
};
};
dojo.lang.curry=function(ns,func){
var _17e=[];
ns=ns||dj_global;
if(dojo.lang.isString(func)){
func=ns[func];
}
for(var x=2;x<arguments.length;x++){
_17e.push(arguments[x]);
}
var _180=(func["__preJoinArity"]||func.length)-_17e.length;
function gather(_181,_182,_183){
var _184=_183;
var _185=_182.slice(0);
for(var x=0;x<_181.length;x++){
_185.push(_181[x]);
}
_183=_183-_181.length;
if(_183<=0){
var res=func.apply(ns,_185);
_183=_184;
return res;
}else{
return function(){
return gather(arguments,_185,_183);
};
}
}
return gather([],_17e,_180);
};
dojo.lang.curryArguments=function(ns,func,args,_18b){
var _18c=[];
var x=_18b||0;
for(x=_18b;x<args.length;x++){
_18c.push(args[x]);
}
return dojo.lang.curry.apply(dojo.lang,[ns,func].concat(_18c));
};
dojo.lang.tryThese=function(){
for(var x=0;x<arguments.length;x++){
try{
if(typeof arguments[x]=="function"){
var ret=(arguments[x]());
if(ret){
return ret;
}
}
}
catch(e){
dojo.debug(e);
}
}
};
dojo.lang.delayThese=function(farr,cb,_192,_193){
if(!farr.length){
if(typeof _193=="function"){
_193();
}
return;
}
if((typeof _192=="undefined")&&(typeof cb=="number")){
_192=cb;
cb=function(){
};
}else{
if(!cb){
cb=function(){
};
if(!_192){
_192=0;
}
}
}
setTimeout(function(){
(farr.shift())();
cb();
dojo.lang.delayThese(farr,cb,_192,_193);
},_192);
};
dojo.provide("dojo.event.common");
dojo.event=new function(){
this._canTimeout=dojo.lang.isFunction(dj_global["setTimeout"])||dojo.lang.isAlien(dj_global["setTimeout"]);
function interpolateArgs(args,_195){
var dl=dojo.lang;
var ao={srcObj:dj_global,srcFunc:null,adviceObj:dj_global,adviceFunc:null,aroundObj:null,aroundFunc:null,adviceType:(args.length>2)?args[0]:"after",precedence:"last",once:false,delay:null,rate:0,adviceMsg:false};
switch(args.length){
case 0:
return;
case 1:
return;
case 2:
ao.srcFunc=args[0];
ao.adviceFunc=args[1];
break;
case 3:
if((dl.isObject(args[0]))&&(dl.isString(args[1]))&&(dl.isString(args[2]))){
ao.adviceType="after";
ao.srcObj=args[0];
ao.srcFunc=args[1];
ao.adviceFunc=args[2];
}else{
if((dl.isString(args[1]))&&(dl.isString(args[2]))){
ao.srcFunc=args[1];
ao.adviceFunc=args[2];
}else{
if((dl.isObject(args[0]))&&(dl.isString(args[1]))&&(dl.isFunction(args[2]))){
ao.adviceType="after";
ao.srcObj=args[0];
ao.srcFunc=args[1];
var _198=dl.nameAnonFunc(args[2],ao.adviceObj,_195);
ao.adviceFunc=_198;
}else{
if((dl.isFunction(args[0]))&&(dl.isObject(args[1]))&&(dl.isString(args[2]))){
ao.adviceType="after";
ao.srcObj=dj_global;
var _198=dl.nameAnonFunc(args[0],ao.srcObj,_195);
ao.srcFunc=_198;
ao.adviceObj=args[1];
ao.adviceFunc=args[2];
}
}
}
}
break;
case 4:
if((dl.isObject(args[0]))&&(dl.isObject(args[2]))){
ao.adviceType="after";
ao.srcObj=args[0];
ao.srcFunc=args[1];
ao.adviceObj=args[2];
ao.adviceFunc=args[3];
}else{
if((dl.isString(args[0]))&&(dl.isString(args[1]))&&(dl.isObject(args[2]))){
ao.adviceType=args[0];
ao.srcObj=dj_global;
ao.srcFunc=args[1];
ao.adviceObj=args[2];
ao.adviceFunc=args[3];
}else{
if((dl.isString(args[0]))&&(dl.isFunction(args[1]))&&(dl.isObject(args[2]))){
ao.adviceType=args[0];
ao.srcObj=dj_global;
var _198=dl.nameAnonFunc(args[1],dj_global,_195);
ao.srcFunc=_198;
ao.adviceObj=args[2];
ao.adviceFunc=args[3];
}else{
if((dl.isString(args[0]))&&(dl.isObject(args[1]))&&(dl.isString(args[2]))&&(dl.isFunction(args[3]))){
ao.srcObj=args[1];
ao.srcFunc=args[2];
var _198=dl.nameAnonFunc(args[3],dj_global,_195);
ao.adviceObj=dj_global;
ao.adviceFunc=_198;
}else{
if(dl.isObject(args[1])){
ao.srcObj=args[1];
ao.srcFunc=args[2];
ao.adviceObj=dj_global;
ao.adviceFunc=args[3];
}else{
if(dl.isObject(args[2])){
ao.srcObj=dj_global;
ao.srcFunc=args[1];
ao.adviceObj=args[2];
ao.adviceFunc=args[3];
}else{
ao.srcObj=ao.adviceObj=ao.aroundObj=dj_global;
ao.srcFunc=args[1];
ao.adviceFunc=args[2];
ao.aroundFunc=args[3];
}
}
}
}
}
}
break;
case 6:
ao.srcObj=args[1];
ao.srcFunc=args[2];
ao.adviceObj=args[3];
ao.adviceFunc=args[4];
ao.aroundFunc=args[5];
ao.aroundObj=dj_global;
break;
default:
ao.srcObj=args[1];
ao.srcFunc=args[2];
ao.adviceObj=args[3];
ao.adviceFunc=args[4];
ao.aroundObj=args[5];
ao.aroundFunc=args[6];
ao.once=args[7];
ao.delay=args[8];
ao.rate=args[9];
ao.adviceMsg=args[10];
break;
}
if(dl.isFunction(ao.aroundFunc)){
var _198=dl.nameAnonFunc(ao.aroundFunc,ao.aroundObj,_195);
ao.aroundFunc=_198;
}
if(dl.isFunction(ao.srcFunc)){
ao.srcFunc=dl.getNameInObj(ao.srcObj,ao.srcFunc);
}
if(dl.isFunction(ao.adviceFunc)){
ao.adviceFunc=dl.getNameInObj(ao.adviceObj,ao.adviceFunc);
}
if((ao.aroundObj)&&(dl.isFunction(ao.aroundFunc))){
ao.aroundFunc=dl.getNameInObj(ao.aroundObj,ao.aroundFunc);
}
if(!ao.srcObj){
dojo.raise("bad srcObj for srcFunc: "+ao.srcFunc);
}
if(!ao.adviceObj){
dojo.raise("bad adviceObj for adviceFunc: "+ao.adviceFunc);
}
if(!ao.adviceFunc){
dojo.debug("bad adviceFunc for srcFunc: "+ao.srcFunc);
dojo.debugShallow(ao);
}
return ao;
}
this.connect=function(){
if(arguments.length==1){
var ao=arguments[0];
}else{
var ao=interpolateArgs(arguments,true);
}
if(dojo.lang.isString(ao.srcFunc)&&(ao.srcFunc.toLowerCase()=="onkey")){
if(dojo.render.html.ie){
ao.srcFunc="onkeydown";
this.connect(ao);
}
ao.srcFunc="onkeypress";
}
if(dojo.lang.isArray(ao.srcObj)&&ao.srcObj!=""){
var _19a={};
for(var x in ao){
_19a[x]=ao[x];
}
var mjps=[];
dojo.lang.forEach(ao.srcObj,function(src){
if((dojo.render.html.capable)&&(dojo.lang.isString(src))){
src=dojo.byId(src);
}
_19a.srcObj=src;
mjps.push(dojo.event.connect.call(dojo.event,_19a));
});
return mjps;
}
var mjp=dojo.event.MethodJoinPoint.getForMethod(ao.srcObj,ao.srcFunc);
if(ao.adviceFunc){
var mjp2=dojo.event.MethodJoinPoint.getForMethod(ao.adviceObj,ao.adviceFunc);
}
mjp.kwAddAdvice(ao);
return mjp;
};
this.log=function(a1,a2){
var _1a2;
if((arguments.length==1)&&(typeof a1=="object")){
_1a2=a1;
}else{
_1a2={srcObj:a1,srcFunc:a2};
}
_1a2.adviceFunc=function(){
var _1a3=[];
for(var x=0;x<arguments.length;x++){
_1a3.push(arguments[x]);
}
dojo.debug("("+_1a2.srcObj+")."+_1a2.srcFunc,":",_1a3.join(", "));
};
this.kwConnect(_1a2);
};
this.connectBefore=function(){
var args=["before"];
for(var i=0;i<arguments.length;i++){
args.push(arguments[i]);
}
return this.connect.apply(this,args);
};
this.connectAround=function(){
var args=["around"];
for(var i=0;i<arguments.length;i++){
args.push(arguments[i]);
}
return this.connect.apply(this,args);
};
this.connectOnce=function(){
var ao=interpolateArgs(arguments,true);
ao.once=true;
return this.connect(ao);
};
this._kwConnectImpl=function(_1aa,_1ab){
var fn=(_1ab)?"disconnect":"connect";
if(typeof _1aa["srcFunc"]=="function"){
_1aa.srcObj=_1aa["srcObj"]||dj_global;
var _1ad=dojo.lang.nameAnonFunc(_1aa.srcFunc,_1aa.srcObj,true);
_1aa.srcFunc=_1ad;
}
if(typeof _1aa["adviceFunc"]=="function"){
_1aa.adviceObj=_1aa["adviceObj"]||dj_global;
var _1ad=dojo.lang.nameAnonFunc(_1aa.adviceFunc,_1aa.adviceObj,true);
_1aa.adviceFunc=_1ad;
}
_1aa.srcObj=_1aa["srcObj"]||dj_global;
_1aa.adviceObj=_1aa["adviceObj"]||_1aa["targetObj"]||dj_global;
_1aa.adviceFunc=_1aa["adviceFunc"]||_1aa["targetFunc"];
return dojo.event[fn](_1aa);
};
this.kwConnect=function(_1ae){
return this._kwConnectImpl(_1ae,false);
};
this.disconnect=function(){
if(arguments.length==1){
var ao=arguments[0];
}else{
var ao=interpolateArgs(arguments,true);
}
if(!ao.adviceFunc){
return;
}
if(dojo.lang.isString(ao.srcFunc)&&(ao.srcFunc.toLowerCase()=="onkey")){
if(dojo.render.html.ie){
ao.srcFunc="onkeydown";
this.disconnect(ao);
}
ao.srcFunc="onkeypress";
}
var mjp=dojo.event.MethodJoinPoint.getForMethod(ao.srcObj,ao.srcFunc);
return mjp.removeAdvice(ao.adviceObj,ao.adviceFunc,ao.adviceType,ao.once);
};
this.kwDisconnect=function(_1b1){
return this._kwConnectImpl(_1b1,true);
};
};
dojo.event.MethodInvocation=function(_1b2,obj,args){
this.jp_=_1b2;
this.object=obj;
this.args=[];
for(var x=0;x<args.length;x++){
this.args[x]=args[x];
}
this.around_index=-1;
};
dojo.event.MethodInvocation.prototype.proceed=function(){
this.around_index++;
if(this.around_index>=this.jp_.around.length){
return this.jp_.object[this.jp_.methodname].apply(this.jp_.object,this.args);
}else{
var ti=this.jp_.around[this.around_index];
var mobj=ti[0]||dj_global;
var meth=ti[1];
return mobj[meth].call(mobj,this);
}
};
dojo.event.MethodJoinPoint=function(obj,_1ba){
this.object=obj||dj_global;
this.methodname=_1ba;
this.methodfunc=this.object[_1ba];
this.squelch=false;
};
dojo.event.MethodJoinPoint.getForMethod=function(obj,_1bc){
if(!obj){
obj=dj_global;
}
if(!obj[_1bc]){
obj[_1bc]=function(){
};
if(!obj[_1bc]){
dojo.raise("Cannot set do-nothing method on that object "+_1bc);
}
}else{
if((!dojo.lang.isFunction(obj[_1bc]))&&(!dojo.lang.isAlien(obj[_1bc]))){
return null;
}
}
var _1bd=_1bc+"$joinpoint";
var _1be=_1bc+"$joinpoint$method";
var _1bf=obj[_1bd];
if(!_1bf){
var _1c0=false;
if(dojo.event["browser"]){
if((obj["attachEvent"])||(obj["nodeType"])||(obj["addEventListener"])){
_1c0=true;
dojo.event.browser.addClobberNodeAttrs(obj,[_1bd,_1be,_1bc]);
}
}
var _1c1=obj[_1bc].length;
obj[_1be]=obj[_1bc];
_1bf=obj[_1bd]=new dojo.event.MethodJoinPoint(obj,_1be);
obj[_1bc]=function(){
var args=[];
if((_1c0)&&(!arguments.length)){
var evt=null;
try{
if(obj.ownerDocument){
evt=obj.ownerDocument.parentWindow.event;
}else{
if(obj.documentElement){
evt=obj.documentElement.ownerDocument.parentWindow.event;
}else{
if(obj.event){
evt=obj.event;
}else{
evt=window.event;
}
}
}
}
catch(e){
evt=window.event;
}
if(evt){
args.push(dojo.event.browser.fixEvent(evt,this));
}
}else{
for(var x=0;x<arguments.length;x++){
if((x==0)&&(_1c0)&&(dojo.event.browser.isEvent(arguments[x]))){
args.push(dojo.event.browser.fixEvent(arguments[x],this));
}else{
args.push(arguments[x]);
}
}
}
return _1bf.run.apply(_1bf,args);
};
obj[_1bc].__preJoinArity=_1c1;
}
return _1bf;
};
dojo.lang.extend(dojo.event.MethodJoinPoint,{unintercept:function(){
this.object[this.methodname]=this.methodfunc;
this.before=[];
this.after=[];
this.around=[];
},disconnect:dojo.lang.forward("unintercept"),run:function(){
var obj=this.object||dj_global;
var args=arguments;
var _1c7=[];
for(var x=0;x<args.length;x++){
_1c7[x]=args[x];
}
var _1c9=function(marr){
if(!marr){
dojo.debug("Null argument to unrollAdvice()");
return;
}
var _1cb=marr[0]||dj_global;
var _1cc=marr[1];
if(!_1cb[_1cc]){
dojo.raise("function \""+_1cc+"\" does not exist on \""+_1cb+"\"");
}
var _1cd=marr[2]||dj_global;
var _1ce=marr[3];
var msg=marr[6];
var _1d0;
var to={args:[],jp_:this,object:obj,proceed:function(){
return _1cb[_1cc].apply(_1cb,to.args);
}};
to.args=_1c7;
var _1d2=parseInt(marr[4]);
var _1d3=((!isNaN(_1d2))&&(marr[4]!==null)&&(typeof marr[4]!="undefined"));
if(marr[5]){
var rate=parseInt(marr[5]);
var cur=new Date();
var _1d6=false;
if((marr["last"])&&((cur-marr.last)<=rate)){
if(dojo.event._canTimeout){
if(marr["delayTimer"]){
clearTimeout(marr.delayTimer);
}
var tod=parseInt(rate*2);
var mcpy=dojo.lang.shallowCopy(marr);
marr.delayTimer=setTimeout(function(){
mcpy[5]=0;
_1c9(mcpy);
},tod);
}
return;
}else{
marr.last=cur;
}
}
if(_1ce){
_1cd[_1ce].call(_1cd,to);
}else{
if((_1d3)&&((dojo.render.html)||(dojo.render.svg))){
dj_global["setTimeout"](function(){
if(msg){
_1cb[_1cc].call(_1cb,to);
}else{
_1cb[_1cc].apply(_1cb,args);
}
},_1d2);
}else{
if(msg){
_1cb[_1cc].call(_1cb,to);
}else{
_1cb[_1cc].apply(_1cb,args);
}
}
}
};
var _1d9=function(){
if(this.squelch){
try{
return _1c9.apply(this,arguments);
}
catch(e){
dojo.debug(e);
}
}else{
return _1c9.apply(this,arguments);
}
};
if((this["before"])&&(this.before.length>0)){
dojo.lang.forEach(this.before.concat(new Array()),_1d9);
}
var _1da;
try{
if((this["around"])&&(this.around.length>0)){
var mi=new dojo.event.MethodInvocation(this,obj,args);
_1da=mi.proceed();
}else{
if(this.methodfunc){
_1da=this.object[this.methodname].apply(this.object,args);
}
}
}
catch(e){
if(!this.squelch){
dojo.raise(e);
}
}
if((this["after"])&&(this.after.length>0)){
dojo.lang.forEach(this.after.concat(new Array()),_1d9);
}
return (this.methodfunc)?_1da:null;
},getArr:function(kind){
var type="after";
if((typeof kind=="string")&&(kind.indexOf("before")!=-1)){
type="before";
}else{
if(kind=="around"){
type="around";
}
}
if(!this[type]){
this[type]=[];
}
return this[type];
},kwAddAdvice:function(args){
this.addAdvice(args["adviceObj"],args["adviceFunc"],args["aroundObj"],args["aroundFunc"],args["adviceType"],args["precedence"],args["once"],args["delay"],args["rate"],args["adviceMsg"]);
},addAdvice:function(_1df,_1e0,_1e1,_1e2,_1e3,_1e4,once,_1e6,rate,_1e8){
var arr=this.getArr(_1e3);
if(!arr){
dojo.raise("bad this: "+this);
}
var ao=[_1df,_1e0,_1e1,_1e2,_1e6,rate,_1e8];
if(once){
if(this.hasAdvice(_1df,_1e0,_1e3,arr)>=0){
return;
}
}
if(_1e4=="first"){
arr.unshift(ao);
}else{
arr.push(ao);
}
},hasAdvice:function(_1eb,_1ec,_1ed,arr){
if(!arr){
arr=this.getArr(_1ed);
}
var ind=-1;
for(var x=0;x<arr.length;x++){
var aao=(typeof _1ec=="object")?(new String(_1ec)).toString():_1ec;
var a1o=(typeof arr[x][1]=="object")?(new String(arr[x][1])).toString():arr[x][1];
if((arr[x][0]==_1eb)&&(a1o==aao)){
ind=x;
}
}
return ind;
},removeAdvice:function(_1f3,_1f4,_1f5,once){
var arr=this.getArr(_1f5);
var ind=this.hasAdvice(_1f3,_1f4,_1f5,arr);
if(ind==-1){
return false;
}
while(ind!=-1){
arr.splice(ind,1);
if(once){
break;
}
ind=this.hasAdvice(_1f3,_1f4,_1f5,arr);
}
return true;
}});
dojo.provide("dojo.event.topic");
dojo.event.topic=new function(){
this.topics={};
this.getTopic=function(_1f9){
if(!this.topics[_1f9]){
this.topics[_1f9]=new this.TopicImpl(_1f9);
}
return this.topics[_1f9];
};
this.registerPublisher=function(_1fa,obj,_1fc){
var _1fa=this.getTopic(_1fa);
_1fa.registerPublisher(obj,_1fc);
};
this.subscribe=function(_1fd,obj,_1ff){
var _1fd=this.getTopic(_1fd);
_1fd.subscribe(obj,_1ff);
};
this.unsubscribe=function(_200,obj,_202){
var _200=this.getTopic(_200);
_200.unsubscribe(obj,_202);
};
this.destroy=function(_203){
this.getTopic(_203).destroy();
delete this.topics[_203];
};
this.publishApply=function(_204,args){
var _204=this.getTopic(_204);
_204.sendMessage.apply(_204,args);
};
this.publish=function(_206,_207){
var _206=this.getTopic(_206);
var args=[];
for(var x=1;x<arguments.length;x++){
args.push(arguments[x]);
}
_206.sendMessage.apply(_206,args);
};
};
dojo.event.topic.TopicImpl=function(_20a){
this.topicName=_20a;
this.subscribe=function(_20b,_20c){
var tf=_20c||_20b;
var to=(!_20c)?dj_global:_20b;
return dojo.event.kwConnect({srcObj:this,srcFunc:"sendMessage",adviceObj:to,adviceFunc:tf});
};
this.unsubscribe=function(_20f,_210){
var tf=(!_210)?_20f:_210;
var to=(!_210)?null:_20f;
return dojo.event.kwDisconnect({srcObj:this,srcFunc:"sendMessage",adviceObj:to,adviceFunc:tf});
};
this._getJoinPoint=function(){
return dojo.event.MethodJoinPoint.getForMethod(this,"sendMessage");
};
this.setSquelch=function(_213){
this._getJoinPoint().squelch=_213;
};
this.destroy=function(){
this._getJoinPoint().disconnect();
};
this.registerPublisher=function(_214,_215){
dojo.event.connect(_214,_215,this,"sendMessage");
};
this.sendMessage=function(_216){
};
};
dojo.provide("dojo.event.browser");
dojo._ie_clobber=new function(){
this.clobberNodes=[];
function nukeProp(node,prop){
try{
node[prop]=null;
}
catch(e){
}
try{
delete node[prop];
}
catch(e){
}
try{
node.removeAttribute(prop);
}
catch(e){
}
}
this.clobber=function(_219){
var na;
var tna;
if(_219){
tna=_219.all||_219.getElementsByTagName("*");
na=[_219];
for(var x=0;x<tna.length;x++){
if(tna[x]["__doClobber__"]){
na.push(tna[x]);
}
}
}else{
try{
window.onload=null;
}
catch(e){
}
na=(this.clobberNodes.length)?this.clobberNodes:document.all;
}
tna=null;
var _21d={};
for(var i=na.length-1;i>=0;i=i-1){
var el=na[i];
try{
if(el&&el["__clobberAttrs__"]){
for(var j=0;j<el.__clobberAttrs__.length;j++){
nukeProp(el,el.__clobberAttrs__[j]);
}
nukeProp(el,"__clobberAttrs__");
nukeProp(el,"__doClobber__");
}
}
catch(e){
}
}
na=null;
};
};
if(dojo.render.html.ie){
dojo.addOnUnload(function(){
dojo._ie_clobber.clobber();
try{
if((dojo["widget"])&&(dojo.widget["manager"])){
dojo.widget.manager.destroyAll();
}
}
catch(e){
}
try{
window.onload=null;
}
catch(e){
}
try{
window.onunload=null;
}
catch(e){
}
dojo._ie_clobber.clobberNodes=[];
});
}
dojo.event.browser=new function(){
var _221=0;
this.normalizedEventName=function(_222){
switch(_222){
case "CheckboxStateChange":
case "DOMAttrModified":
case "DOMMenuItemActive":
case "DOMMenuItemInactive":
case "DOMMouseScroll":
case "DOMNodeInserted":
case "DOMNodeRemoved":
case "RadioStateChange":
return _222;
break;
default:
return _222.toLowerCase();
break;
}
};
this.clean=function(node){
if(dojo.render.html.ie){
dojo._ie_clobber.clobber(node);
}
};
this.addClobberNode=function(node){
if(!dojo.render.html.ie){
return;
}
if(!node["__doClobber__"]){
node.__doClobber__=true;
dojo._ie_clobber.clobberNodes.push(node);
node.__clobberAttrs__=[];
}
};
this.addClobberNodeAttrs=function(node,_226){
if(!dojo.render.html.ie){
return;
}
this.addClobberNode(node);
for(var x=0;x<_226.length;x++){
node.__clobberAttrs__.push(_226[x]);
}
};
this.removeListener=function(node,_229,fp,_22b){
if(!_22b){
var _22b=false;
}
_229=dojo.event.browser.normalizedEventName(_229);
if((_229=="onkey")||(_229=="key")){
if(dojo.render.html.ie){
this.removeListener(node,"onkeydown",fp,_22b);
}
_229="onkeypress";
}
if(_229.substr(0,2)=="on"){
_229=_229.substr(2);
}
if(node.removeEventListener){
node.removeEventListener(_229,fp,_22b);
}
};
this.addListener=function(node,_22d,fp,_22f,_230){
if(!node){
return;
}
if(!_22f){
var _22f=false;
}
_22d=dojo.event.browser.normalizedEventName(_22d);
if((_22d=="onkey")||(_22d=="key")){
if(dojo.render.html.ie){
this.addListener(node,"onkeydown",fp,_22f,_230);
}
_22d="onkeypress";
}
if(_22d.substr(0,2)!="on"){
_22d="on"+_22d;
}
if(!_230){
var _231=function(evt){
if(!evt){
evt=window.event;
}
var ret=fp(dojo.event.browser.fixEvent(evt,this));
if(_22f){
dojo.event.browser.stopEvent(evt);
}
return ret;
};
}else{
_231=fp;
}
if(node.addEventListener){
node.addEventListener(_22d.substr(2),_231,_22f);
return _231;
}else{
if(typeof node[_22d]=="function"){
var _234=node[_22d];
node[_22d]=function(e){
_234(e);
return _231(e);
};
}else{
node[_22d]=_231;
}
if(dojo.render.html.ie){
this.addClobberNodeAttrs(node,[_22d]);
}
return _231;
}
};
this.isEvent=function(obj){
return (typeof obj!="undefined")&&(typeof Event!="undefined")&&(obj.eventPhase);
};
this.currentEvent=null;
this.callListener=function(_237,_238){
if(typeof _237!="function"){
dojo.raise("listener not a function: "+_237);
}
dojo.event.browser.currentEvent.currentTarget=_238;
return _237.call(_238,dojo.event.browser.currentEvent);
};
this._stopPropagation=function(){
dojo.event.browser.currentEvent.cancelBubble=true;
};
this._preventDefault=function(){
dojo.event.browser.currentEvent.returnValue=false;
};
this.keys={KEY_BACKSPACE:8,KEY_TAB:9,KEY_CLEAR:12,KEY_ENTER:13,KEY_SHIFT:16,KEY_CTRL:17,KEY_ALT:18,KEY_PAUSE:19,KEY_CAPS_LOCK:20,KEY_ESCAPE:27,KEY_SPACE:32,KEY_PAGE_UP:33,KEY_PAGE_DOWN:34,KEY_END:35,KEY_HOME:36,KEY_LEFT_ARROW:37,KEY_UP_ARROW:38,KEY_RIGHT_ARROW:39,KEY_DOWN_ARROW:40,KEY_INSERT:45,KEY_DELETE:46,KEY_HELP:47,KEY_LEFT_WINDOW:91,KEY_RIGHT_WINDOW:92,KEY_SELECT:93,KEY_NUMPAD_0:96,KEY_NUMPAD_1:97,KEY_NUMPAD_2:98,KEY_NUMPAD_3:99,KEY_NUMPAD_4:100,KEY_NUMPAD_5:101,KEY_NUMPAD_6:102,KEY_NUMPAD_7:103,KEY_NUMPAD_8:104,KEY_NUMPAD_9:105,KEY_NUMPAD_MULTIPLY:106,KEY_NUMPAD_PLUS:107,KEY_NUMPAD_ENTER:108,KEY_NUMPAD_MINUS:109,KEY_NUMPAD_PERIOD:110,KEY_NUMPAD_DIVIDE:111,KEY_F1:112,KEY_F2:113,KEY_F3:114,KEY_F4:115,KEY_F5:116,KEY_F6:117,KEY_F7:118,KEY_F8:119,KEY_F9:120,KEY_F10:121,KEY_F11:122,KEY_F12:123,KEY_F13:124,KEY_F14:125,KEY_F15:126,KEY_NUM_LOCK:144,KEY_SCROLL_LOCK:145};
this.revKeys=[];
for(var key in this.keys){
this.revKeys[this.keys[key]]=key;
}
this.fixEvent=function(evt,_23b){
if(!evt){
if(window["event"]){
evt=window.event;
}
}
if((evt["type"])&&(evt["type"].indexOf("key")==0)){
evt.keys=this.revKeys;
for(var key in this.keys){
evt[key]=this.keys[key];
}
if(evt["type"]=="keydown"&&dojo.render.html.ie){
switch(evt.keyCode){
case evt.KEY_SHIFT:
case evt.KEY_CTRL:
case evt.KEY_ALT:
case evt.KEY_CAPS_LOCK:
case evt.KEY_LEFT_WINDOW:
case evt.KEY_RIGHT_WINDOW:
case evt.KEY_SELECT:
case evt.KEY_NUM_LOCK:
case evt.KEY_SCROLL_LOCK:
case evt.KEY_NUMPAD_0:
case evt.KEY_NUMPAD_1:
case evt.KEY_NUMPAD_2:
case evt.KEY_NUMPAD_3:
case evt.KEY_NUMPAD_4:
case evt.KEY_NUMPAD_5:
case evt.KEY_NUMPAD_6:
case evt.KEY_NUMPAD_7:
case evt.KEY_NUMPAD_8:
case evt.KEY_NUMPAD_9:
case evt.KEY_NUMPAD_PERIOD:
break;
case evt.KEY_NUMPAD_MULTIPLY:
case evt.KEY_NUMPAD_PLUS:
case evt.KEY_NUMPAD_ENTER:
case evt.KEY_NUMPAD_MINUS:
case evt.KEY_NUMPAD_DIVIDE:
break;
case evt.KEY_PAUSE:
case evt.KEY_TAB:
case evt.KEY_BACKSPACE:
case evt.KEY_ENTER:
case evt.KEY_ESCAPE:
case evt.KEY_PAGE_UP:
case evt.KEY_PAGE_DOWN:
case evt.KEY_END:
case evt.KEY_HOME:
case evt.KEY_LEFT_ARROW:
case evt.KEY_UP_ARROW:
case evt.KEY_RIGHT_ARROW:
case evt.KEY_DOWN_ARROW:
case evt.KEY_INSERT:
case evt.KEY_DELETE:
case evt.KEY_F1:
case evt.KEY_F2:
case evt.KEY_F3:
case evt.KEY_F4:
case evt.KEY_F5:
case evt.KEY_F6:
case evt.KEY_F7:
case evt.KEY_F8:
case evt.KEY_F9:
case evt.KEY_F10:
case evt.KEY_F11:
case evt.KEY_F12:
case evt.KEY_F12:
case evt.KEY_F13:
case evt.KEY_F14:
case evt.KEY_F15:
case evt.KEY_CLEAR:
case evt.KEY_HELP:
evt.key=evt.keyCode;
break;
default:
if(evt.ctrlKey||evt.altKey){
var _23d=evt.keyCode;
if(_23d>=65&&_23d<=90&&evt.shiftKey==false){
_23d+=32;
}
if(_23d>=1&&_23d<=26&&evt.ctrlKey){
_23d+=96;
}
evt.key=String.fromCharCode(_23d);
}
}
}else{
if(evt["type"]=="keypress"){
if(dojo.render.html.opera){
if(evt.which==0){
evt.key=evt.keyCode;
}else{
if(evt.which>0){
switch(evt.which){
case evt.KEY_SHIFT:
case evt.KEY_CTRL:
case evt.KEY_ALT:
case evt.KEY_CAPS_LOCK:
case evt.KEY_NUM_LOCK:
case evt.KEY_SCROLL_LOCK:
break;
case evt.KEY_PAUSE:
case evt.KEY_TAB:
case evt.KEY_BACKSPACE:
case evt.KEY_ENTER:
case evt.KEY_ESCAPE:
evt.key=evt.which;
break;
default:
var _23d=evt.which;
if((evt.ctrlKey||evt.altKey||evt.metaKey)&&(evt.which>=65&&evt.which<=90&&evt.shiftKey==false)){
_23d+=32;
}
evt.key=String.fromCharCode(_23d);
}
}
}
}else{
if(dojo.render.html.ie){
if(!evt.ctrlKey&&!evt.altKey&&evt.keyCode>=evt.KEY_SPACE){
evt.key=String.fromCharCode(evt.keyCode);
}
}else{
if(dojo.render.html.safari){
switch(evt.keyCode){
case 63232:
evt.key=evt.KEY_UP_ARROW;
break;
case 63233:
evt.key=evt.KEY_DOWN_ARROW;
break;
case 63234:
evt.key=evt.KEY_LEFT_ARROW;
break;
case 63235:
evt.key=evt.KEY_RIGHT_ARROW;
break;
default:
evt.key=evt.charCode>0?String.fromCharCode(evt.charCode):evt.keyCode;
}
}else{
evt.key=evt.charCode>0?String.fromCharCode(evt.charCode):evt.keyCode;
}
}
}
}
}
}
if(dojo.render.html.ie){
if(!evt.target){
evt.target=evt.srcElement;
}
if(!evt.currentTarget){
evt.currentTarget=(_23b?_23b:evt.srcElement);
}
if(!evt.layerX){
evt.layerX=evt.offsetX;
}
if(!evt.layerY){
evt.layerY=evt.offsetY;
}
var doc=(evt.srcElement&&evt.srcElement.ownerDocument)?evt.srcElement.ownerDocument:document;
var _23f=((dojo.render.html.ie55)||(doc["compatMode"]=="BackCompat"))?doc.body:doc.documentElement;
if(!evt.pageX){
evt.pageX=evt.clientX+(_23f.scrollLeft||0);
}
if(!evt.pageY){
evt.pageY=evt.clientY+(_23f.scrollTop||0);
}
if(evt.type=="mouseover"){
evt.relatedTarget=evt.fromElement;
}
if(evt.type=="mouseout"){
evt.relatedTarget=evt.toElement;
}
this.currentEvent=evt;
evt.callListener=this.callListener;
evt.stopPropagation=this._stopPropagation;
evt.preventDefault=this._preventDefault;
}
return evt;
};
this.stopEvent=function(evt){
if(window.event){
evt.returnValue=false;
evt.cancelBubble=true;
}else{
evt.preventDefault();
evt.stopPropagation();
}
};
};
dojo.provide("dojo.event.*");
dojo.provide("dojo.string.common");
dojo.string.trim=function(str,wh){
if(!str.replace){
return str;
}
if(!str.length){
return str;
}
var re=(wh>0)?(/^\s+/):(wh<0)?(/\s+$/):(/^\s+|\s+$/g);
return str.replace(re,"");
};
dojo.string.trimStart=function(str){
return dojo.string.trim(str,1);
};
dojo.string.trimEnd=function(str){
return dojo.string.trim(str,-1);
};
dojo.string.repeat=function(str,_247,_248){
var out="";
for(var i=0;i<_247;i++){
out+=str;
if(_248&&i<_247-1){
out+=_248;
}
}
return out;
};
dojo.string.pad=function(str,len,c,dir){
var out=String(str);
if(!c){
c="0";
}
if(!dir){
dir=1;
}
while(out.length<len){
if(dir>0){
out=c+out;
}else{
out+=c;
}
}
return out;
};
dojo.string.padLeft=function(str,len,c){
return dojo.string.pad(str,len,c,1);
};
dojo.string.padRight=function(str,len,c){
return dojo.string.pad(str,len,c,-1);
};
dojo.provide("dojo.string");
dojo.provide("dojo.io.common");
dojo.io.transports=[];
dojo.io.hdlrFuncNames=["load","error","timeout"];
dojo.io.Request=function(url,_257,_258,_259){
if((arguments.length==1)&&(arguments[0].constructor==Object)){
this.fromKwArgs(arguments[0]);
}else{
this.url=url;
if(_257){
this.mimetype=_257;
}
if(_258){
this.transport=_258;
}
if(arguments.length>=4){
this.changeUrl=_259;
}
}
};
dojo.lang.extend(dojo.io.Request,{url:"",mimetype:"text/plain",method:"GET",content:undefined,transport:undefined,changeUrl:undefined,formNode:undefined,sync:false,bindSuccess:false,useCache:false,preventCache:false,load:function(type,data,_25c,_25d){
},error:function(type,_25f,_260,_261){
},timeout:function(type,_263,_264,_265){
},handle:function(type,data,_268,_269){
},timeoutSeconds:0,abort:function(){
},fromKwArgs:function(_26a){
if(_26a["url"]){
_26a.url=_26a.url.toString();
}
if(_26a["formNode"]){
_26a.formNode=dojo.byId(_26a.formNode);
}
if(!_26a["method"]&&_26a["formNode"]&&_26a["formNode"].method){
_26a.method=_26a["formNode"].method;
}
if(!_26a["handle"]&&_26a["handler"]){
_26a.handle=_26a.handler;
}
if(!_26a["load"]&&_26a["loaded"]){
_26a.load=_26a.loaded;
}
if(!_26a["changeUrl"]&&_26a["changeURL"]){
_26a.changeUrl=_26a.changeURL;
}
_26a.encoding=dojo.lang.firstValued(_26a["encoding"],djConfig["bindEncoding"],"");
_26a.sendTransport=dojo.lang.firstValued(_26a["sendTransport"],djConfig["ioSendTransport"],false);
var _26b=dojo.lang.isFunction;
for(var x=0;x<dojo.io.hdlrFuncNames.length;x++){
var fn=dojo.io.hdlrFuncNames[x];
if(_26a[fn]&&_26b(_26a[fn])){
continue;
}
if(_26a["handle"]&&_26b(_26a["handle"])){
_26a[fn]=_26a.handle;
}
}
dojo.lang.mixin(this,_26a);
}});
dojo.io.Error=function(msg,type,num){
this.message=msg;
this.type=type||"unknown";
this.number=num||0;
};
dojo.io.transports.addTransport=function(name){
this.push(name);
this[name]=dojo.io[name];
};
dojo.io.bind=function(_272){
if(!(_272 instanceof dojo.io.Request)){
try{
_272=new dojo.io.Request(_272);
}
catch(e){
dojo.debug(e);
}
}
var _273="";
if(_272["transport"]){
_273=_272["transport"];
if(!this[_273]){
dojo.io.sendBindError(_272,"No dojo.io.bind() transport with name '"+_272["transport"]+"'.");
return _272;
}
if(!this[_273].canHandle(_272)){
dojo.io.sendBindError(_272,"dojo.io.bind() transport with name '"+_272["transport"]+"' cannot handle this type of request.");
return _272;
}
}else{
for(var x=0;x<dojo.io.transports.length;x++){
var tmp=dojo.io.transports[x];
if((this[tmp])&&(this[tmp].canHandle(_272))){
_273=tmp;
break;
}
}
if(_273==""){
dojo.io.sendBindError(_272,"None of the loaded transports for dojo.io.bind()"+" can handle the request.");
return _272;
}
}
this[_273].bind(_272);
_272.bindSuccess=true;
return _272;
};
dojo.io.sendBindError=function(_276,_277){
if((typeof _276.error=="function"||typeof _276.handle=="function")&&(typeof setTimeout=="function"||typeof setTimeout=="object")){
var _278=new dojo.io.Error(_277);
setTimeout(function(){
_276[(typeof _276.error=="function")?"error":"handle"]("error",_278,null,_276);
},50);
}else{
dojo.raise(_277);
}
};
dojo.io.queueBind=function(_279){
if(!(_279 instanceof dojo.io.Request)){
try{
_279=new dojo.io.Request(_279);
}
catch(e){
dojo.debug(e);
}
}
var _27a=_279.load;
_279.load=function(){
dojo.io._queueBindInFlight=false;
var ret=_27a.apply(this,arguments);
dojo.io._dispatchNextQueueBind();
return ret;
};
var _27c=_279.error;
_279.error=function(){
dojo.io._queueBindInFlight=false;
var ret=_27c.apply(this,arguments);
dojo.io._dispatchNextQueueBind();
return ret;
};
dojo.io._bindQueue.push(_279);
dojo.io._dispatchNextQueueBind();
return _279;
};
dojo.io._dispatchNextQueueBind=function(){
if(!dojo.io._queueBindInFlight){
dojo.io._queueBindInFlight=true;
if(dojo.io._bindQueue.length>0){
dojo.io.bind(dojo.io._bindQueue.shift());
}else{
dojo.io._queueBindInFlight=false;
}
}
};
dojo.io._bindQueue=[];
dojo.io._queueBindInFlight=false;
dojo.io.argsFromMap=function(map,_27f,last){
var enc=/utf/i.test(_27f||"")?encodeURIComponent:dojo.string.encodeAscii;
var _282=[];
var _283=new Object();
for(var name in map){
var _285=function(elt){
var val=enc(name)+"="+enc(elt);
_282[(last==name)?"push":"unshift"](val);
};
if(!_283[name]){
var _288=map[name];
if(dojo.lang.isArray(_288)){
dojo.lang.forEach(_288,_285);
}else{
_285(_288);
}
}
}
return _282.join("&");
};
dojo.io.setIFrameSrc=function(_289,src,_28b){
try{
var r=dojo.render.html;
if(!_28b){
if(r.safari){
_289.location=src;
}else{
frames[_289.name].location=src;
}
}else{
var idoc;
if(r.ie){
idoc=_289.contentWindow.document;
}else{
if(r.safari){
idoc=_289.document;
}else{
idoc=_289.contentWindow;
}
}
if(!idoc){
_289.location=src;
return;
}else{
idoc.location.replace(src);
}
}
}
catch(e){
dojo.debug(e);
dojo.debug("setIFrameSrc: "+e);
}
};
dojo.provide("dojo.string.extras");
dojo.string.substituteParams=function(_28e,hash){
var map=(typeof hash=="object")?hash:dojo.lang.toArray(arguments,1);
return _28e.replace(/\%\{(\w+)\}/g,function(_291,key){
if(typeof (map[key])!="undefined"&&map[key]!=null){
return map[key];
}
dojo.raise("Substitution not found: "+key);
});
};
dojo.string.capitalize=function(str){
if(!dojo.lang.isString(str)){
return "";
}
if(arguments.length==0){
str=this;
}
var _294=str.split(" ");
for(var i=0;i<_294.length;i++){
_294[i]=_294[i].charAt(0).toUpperCase()+_294[i].substring(1);
}
return _294.join(" ");
};
dojo.string.isBlank=function(str){
if(!dojo.lang.isString(str)){
return true;
}
return (dojo.string.trim(str).length==0);
};
dojo.string.encodeAscii=function(str){
if(!dojo.lang.isString(str)){
return str;
}
var ret="";
var _299=escape(str);
var _29a,re=/%u([0-9A-F]{4})/i;
while((_29a=_299.match(re))){
var num=Number("0x"+_29a[1]);
var _29d=escape("&#"+num+";");
ret+=_299.substring(0,_29a.index)+_29d;
_299=_299.substring(_29a.index+_29a[0].length);
}
ret+=_299.replace(/\+/g,"%2B");
return ret;
};
dojo.string.escape=function(type,str){
var args=dojo.lang.toArray(arguments,1);
switch(type.toLowerCase()){
case "xml":
case "html":
case "xhtml":
return dojo.string.escapeXml.apply(this,args);
case "sql":
return dojo.string.escapeSql.apply(this,args);
case "regexp":
case "regex":
return dojo.string.escapeRegExp.apply(this,args);
case "javascript":
case "jscript":
case "js":
return dojo.string.escapeJavaScript.apply(this,args);
case "ascii":
return dojo.string.encodeAscii.apply(this,args);
default:
return str;
}
};
dojo.string.escapeXml=function(str,_2a2){
str=str.replace(/&/gm,"&amp;").replace(/</gm,"&lt;").replace(/>/gm,"&gt;").replace(/"/gm,"&quot;");
if(!_2a2){
str=str.replace(/'/gm,"&#39;");
}
return str;
};
dojo.string.escapeSql=function(str){
return str.replace(/'/gm,"''");
};
dojo.string.escapeRegExp=function(str){
return str.replace(/\\/gm,"\\\\").replace(/([\f\b\n\t\r[\^$|?*+(){}])/gm,"\\$1");
};
dojo.string.escapeJavaScript=function(str){
return str.replace(/(["'\f\b\n\t\r])/gm,"\\$1");
};
dojo.string.escapeString=function(str){
return ("\""+str.replace(/(["\\])/g,"\\$1")+"\"").replace(/[\f]/g,"\\f").replace(/[\b]/g,"\\b").replace(/[\n]/g,"\\n").replace(/[\t]/g,"\\t").replace(/[\r]/g,"\\r");
};
dojo.string.summary=function(str,len){
if(!len||str.length<=len){
return str;
}
return str.substring(0,len).replace(/\.+$/,"")+"...";
};
dojo.string.endsWith=function(str,end,_2ab){
if(_2ab){
str=str.toLowerCase();
end=end.toLowerCase();
}
if((str.length-end.length)<0){
return false;
}
return str.lastIndexOf(end)==str.length-end.length;
};
dojo.string.endsWithAny=function(str){
for(var i=1;i<arguments.length;i++){
if(dojo.string.endsWith(str,arguments[i])){
return true;
}
}
return false;
};
dojo.string.startsWith=function(str,_2af,_2b0){
if(_2b0){
str=str.toLowerCase();
_2af=_2af.toLowerCase();
}
return str.indexOf(_2af)==0;
};
dojo.string.startsWithAny=function(str){
for(var i=1;i<arguments.length;i++){
if(dojo.string.startsWith(str,arguments[i])){
return true;
}
}
return false;
};
dojo.string.has=function(str){
for(var i=1;i<arguments.length;i++){
if(str.indexOf(arguments[i])>-1){
return true;
}
}
return false;
};
dojo.string.normalizeNewlines=function(text,_2b6){
if(_2b6=="\n"){
text=text.replace(/\r\n/g,"\n");
text=text.replace(/\r/g,"\n");
}else{
if(_2b6=="\r"){
text=text.replace(/\r\n/g,"\r");
text=text.replace(/\n/g,"\r");
}else{
text=text.replace(/([^\r])\n/g,"$1\r\n").replace(/\r([^\n])/g,"\r\n$1");
}
}
return text;
};
dojo.string.splitEscaped=function(str,_2b8){
var _2b9=[];
for(var i=0,_2bb=0;i<str.length;i++){
if(str.charAt(i)=="\\"){
i++;
continue;
}
if(str.charAt(i)==_2b8){
_2b9.push(str.substring(_2bb,i));
_2bb=i+1;
}
}
_2b9.push(str.substr(_2bb));
return _2b9;
};
dojo.provide("dojo.dom");
dojo.dom.ELEMENT_NODE=1;
dojo.dom.ATTRIBUTE_NODE=2;
dojo.dom.TEXT_NODE=3;
dojo.dom.CDATA_SECTION_NODE=4;
dojo.dom.ENTITY_REFERENCE_NODE=5;
dojo.dom.ENTITY_NODE=6;
dojo.dom.PROCESSING_INSTRUCTION_NODE=7;
dojo.dom.COMMENT_NODE=8;
dojo.dom.DOCUMENT_NODE=9;
dojo.dom.DOCUMENT_TYPE_NODE=10;
dojo.dom.DOCUMENT_FRAGMENT_NODE=11;
dojo.dom.NOTATION_NODE=12;
dojo.dom.dojoml="http://www.dojotoolkit.org/2004/dojoml";
dojo.dom.xmlns={svg:"http://www.w3.org/2000/svg",smil:"http://www.w3.org/2001/SMIL20/",mml:"http://www.w3.org/1998/Math/MathML",cml:"http://www.xml-cml.org",xlink:"http://www.w3.org/1999/xlink",xhtml:"http://www.w3.org/1999/xhtml",xul:"http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul",xbl:"http://www.mozilla.org/xbl",fo:"http://www.w3.org/1999/XSL/Format",xsl:"http://www.w3.org/1999/XSL/Transform",xslt:"http://www.w3.org/1999/XSL/Transform",xi:"http://www.w3.org/2001/XInclude",xforms:"http://www.w3.org/2002/01/xforms",saxon:"http://icl.com/saxon",xalan:"http://xml.apache.org/xslt",xsd:"http://www.w3.org/2001/XMLSchema",dt:"http://www.w3.org/2001/XMLSchema-datatypes",xsi:"http://www.w3.org/2001/XMLSchema-instance",rdf:"http://www.w3.org/1999/02/22-rdf-syntax-ns#",rdfs:"http://www.w3.org/2000/01/rdf-schema#",dc:"http://purl.org/dc/elements/1.1/",dcq:"http://purl.org/dc/qualifiers/1.0","soap-env":"http://schemas.xmlsoap.org/soap/envelope/",wsdl:"http://schemas.xmlsoap.org/wsdl/",AdobeExtensions:"http://ns.adobe.com/AdobeSVGViewerExtensions/3.0/"};
dojo.dom.isNode=function(wh){
if(typeof Element=="function"){
try{
return wh instanceof Element;
}
catch(E){
}
}else{
return wh&&!isNaN(wh.nodeType);
}
};
dojo.dom.getUniqueId=function(){
var _2bd=dojo.doc();
do{
var id="dj_unique_"+(++arguments.callee._idIncrement);
}while(_2bd.getElementById(id));
return id;
};
dojo.dom.getUniqueId._idIncrement=0;
dojo.dom.firstElement=dojo.dom.getFirstChildElement=function(_2bf,_2c0){
var node=_2bf.firstChild;
while(node&&node.nodeType!=dojo.dom.ELEMENT_NODE){
node=node.nextSibling;
}
if(_2c0&&node&&node.tagName&&node.tagName.toLowerCase()!=_2c0.toLowerCase()){
node=dojo.dom.nextElement(node,_2c0);
}
return node;
};
dojo.dom.lastElement=dojo.dom.getLastChildElement=function(_2c2,_2c3){
var node=_2c2.lastChild;
while(node&&node.nodeType!=dojo.dom.ELEMENT_NODE){
node=node.previousSibling;
}
if(_2c3&&node&&node.tagName&&node.tagName.toLowerCase()!=_2c3.toLowerCase()){
node=dojo.dom.prevElement(node,_2c3);
}
return node;
};
dojo.dom.nextElement=dojo.dom.getNextSiblingElement=function(node,_2c6){
if(!node){
return null;
}
do{
node=node.nextSibling;
}while(node&&node.nodeType!=dojo.dom.ELEMENT_NODE);
if(node&&_2c6&&_2c6.toLowerCase()!=node.tagName.toLowerCase()){
return dojo.dom.nextElement(node,_2c6);
}
return node;
};
dojo.dom.prevElement=dojo.dom.getPreviousSiblingElement=function(node,_2c8){
if(!node){
return null;
}
if(_2c8){
_2c8=_2c8.toLowerCase();
}
do{
node=node.previousSibling;
}while(node&&node.nodeType!=dojo.dom.ELEMENT_NODE);
if(node&&_2c8&&_2c8.toLowerCase()!=node.tagName.toLowerCase()){
return dojo.dom.prevElement(node,_2c8);
}
return node;
};
dojo.dom.moveChildren=function(_2c9,_2ca,trim){
var _2cc=0;
if(trim){
while(_2c9.hasChildNodes()&&_2c9.firstChild.nodeType==dojo.dom.TEXT_NODE){
_2c9.removeChild(_2c9.firstChild);
}
while(_2c9.hasChildNodes()&&_2c9.lastChild.nodeType==dojo.dom.TEXT_NODE){
_2c9.removeChild(_2c9.lastChild);
}
}
while(_2c9.hasChildNodes()){
_2ca.appendChild(_2c9.firstChild);
_2cc++;
}
return _2cc;
};
dojo.dom.copyChildren=function(_2cd,_2ce,trim){
var _2d0=_2cd.cloneNode(true);
return this.moveChildren(_2d0,_2ce,trim);
};
dojo.dom.removeChildren=function(node){
var _2d2=node.childNodes.length;
while(node.hasChildNodes()){
node.removeChild(node.firstChild);
}
return _2d2;
};
dojo.dom.replaceChildren=function(node,_2d4){
dojo.dom.removeChildren(node);
node.appendChild(_2d4);
};
dojo.dom.removeNode=function(node){
if(node&&node.parentNode){
return node.parentNode.removeChild(node);
}
};
dojo.dom.getAncestors=function(node,_2d7,_2d8){
var _2d9=[];
var _2da=(_2d7&&(_2d7 instanceof Function||typeof _2d7=="function"));
while(node){
if(!_2da||_2d7(node)){
_2d9.push(node);
}
if(_2d8&&_2d9.length>0){
return _2d9[0];
}
node=node.parentNode;
}
if(_2d8){
return null;
}
return _2d9;
};
dojo.dom.getAncestorsByTag=function(node,tag,_2dd){
tag=tag.toLowerCase();
return dojo.dom.getAncestors(node,function(el){
return ((el.tagName)&&(el.tagName.toLowerCase()==tag));
},_2dd);
};
dojo.dom.getFirstAncestorByTag=function(node,tag){
return dojo.dom.getAncestorsByTag(node,tag,true);
};
dojo.dom.isDescendantOf=function(node,_2e2,_2e3){
if(_2e3&&node){
node=node.parentNode;
}
while(node){
if(node==_2e2){
return true;
}
node=node.parentNode;
}
return false;
};
dojo.dom.innerXML=function(node){
if(node.innerXML){
return node.innerXML;
}else{
if(node.xml){
return node.xml;
}else{
if(typeof XMLSerializer!="undefined"){
return (new XMLSerializer()).serializeToString(node);
}
}
}
};
dojo.dom.createDocument=function(){
var doc=null;
var _2e6=dojo.doc();
if(!dj_undef("ActiveXObject")){
var _2e7=["MSXML2","Microsoft","MSXML","MSXML3"];
for(var i=0;i<_2e7.length;i++){
try{
doc=new ActiveXObject(_2e7[i]+".XMLDOM");
}
catch(e){
}
if(doc){
break;
}
}
}else{
if((_2e6.implementation)&&(_2e6.implementation.createDocument)){
doc=_2e6.implementation.createDocument("","",null);
}
}
return doc;
};
dojo.dom.createDocumentFromText=function(str,_2ea){
if(!_2ea){
_2ea="text/xml";
}
if(!dj_undef("DOMParser")){
var _2eb=new DOMParser();
return _2eb.parseFromString(str,_2ea);
}else{
if(!dj_undef("ActiveXObject")){
var _2ec=dojo.dom.createDocument();
if(_2ec){
_2ec.async=false;
_2ec.loadXML(str);
return _2ec;
}else{
dojo.debug("toXml didn't work?");
}
}else{
var _2ed=dojo.doc();
if(_2ed.createElement){
var tmp=_2ed.createElement("xml");
tmp.innerHTML=str;
if(_2ed.implementation&&_2ed.implementation.createDocument){
var _2ef=_2ed.implementation.createDocument("foo","",null);
for(var i=0;i<tmp.childNodes.length;i++){
_2ef.importNode(tmp.childNodes.item(i),true);
}
return _2ef;
}
return ((tmp.document)&&(tmp.document.firstChild?tmp.document.firstChild:tmp));
}
}
}
return null;
};
dojo.dom.prependChild=function(node,_2f2){
if(_2f2.firstChild){
_2f2.insertBefore(node,_2f2.firstChild);
}else{
_2f2.appendChild(node);
}
return true;
};
dojo.dom.insertBefore=function(node,ref,_2f5){
if(_2f5!=true&&(node===ref||node.nextSibling===ref)){
return false;
}
var _2f6=ref.parentNode;
_2f6.insertBefore(node,ref);
return true;
};
dojo.dom.insertAfter=function(node,ref,_2f9){
var pn=ref.parentNode;
if(ref==pn.lastChild){
if((_2f9!=true)&&(node===ref)){
return false;
}
pn.appendChild(node);
}else{
return this.insertBefore(node,ref.nextSibling,_2f9);
}
return true;
};
dojo.dom.insertAtPosition=function(node,ref,_2fd){
if((!node)||(!ref)||(!_2fd)){
return false;
}
switch(_2fd.toLowerCase()){
case "before":
return dojo.dom.insertBefore(node,ref);
case "after":
return dojo.dom.insertAfter(node,ref);
case "first":
if(ref.firstChild){
return dojo.dom.insertBefore(node,ref.firstChild);
}else{
ref.appendChild(node);
return true;
}
break;
default:
ref.appendChild(node);
return true;
}
};
dojo.dom.insertAtIndex=function(node,_2ff,_300){
var _301=_2ff.childNodes;
if(!_301.length){
_2ff.appendChild(node);
return true;
}
var _302=null;
for(var i=0;i<_301.length;i++){
var _304=_301.item(i)["getAttribute"]?parseInt(_301.item(i).getAttribute("dojoinsertionindex")):-1;
if(_304<_300){
_302=_301.item(i);
}
}
if(_302){
return dojo.dom.insertAfter(node,_302);
}else{
return dojo.dom.insertBefore(node,_301.item(0));
}
};
dojo.dom.textContent=function(node,text){
if(arguments.length>1){
var _307=dojo.doc();
dojo.dom.replaceChildren(node,_307.createTextNode(text));
return text;
}else{
if(node.textContent!=undefined){
return node.textContent;
}
var _308="";
if(node==null){
return _308;
}
for(var i=0;i<node.childNodes.length;i++){
switch(node.childNodes[i].nodeType){
case 1:
case 5:
_308+=dojo.dom.textContent(node.childNodes[i]);
break;
case 3:
case 2:
case 4:
_308+=node.childNodes[i].nodeValue;
break;
default:
break;
}
}
return _308;
}
};
dojo.dom.hasParent=function(node){
return node&&node.parentNode&&dojo.dom.isNode(node.parentNode);
};
dojo.dom.isTag=function(node){
if(node&&node.tagName){
for(var i=1;i<arguments.length;i++){
if(node.tagName==String(arguments[i])){
return String(arguments[i]);
}
}
}
return "";
};
dojo.dom.setAttributeNS=function(elem,_30e,_30f,_310){
if(elem==null||((elem==undefined)&&(typeof elem=="undefined"))){
dojo.raise("No element given to dojo.dom.setAttributeNS");
}
if(!((elem.setAttributeNS==undefined)&&(typeof elem.setAttributeNS=="undefined"))){
elem.setAttributeNS(_30e,_30f,_310);
}else{
var _311=elem.ownerDocument;
var _312=_311.createNode(2,_30f,_30e);
_312.nodeValue=_310;
elem.setAttributeNode(_312);
}
};
dojo.provide("dojo.undo.browser");
try{
if((!djConfig["preventBackButtonFix"])&&(!dojo.hostenv.post_load_)){
document.write("<iframe style='border: 0px; width: 1px; height: 1px; position: absolute; bottom: 0px; right: 0px; visibility: visible;' name='djhistory' id='djhistory' src='"+(dojo.hostenv.getBaseScriptUri()+"iframe_history.html")+"'></iframe>");
}
}
catch(e){
}
if(dojo.render.html.opera){
dojo.debug("Opera is not supported with dojo.undo.browser, so back/forward detection will not work.");
}
dojo.undo.browser={initialHref:window.location.href,initialHash:window.location.hash,moveForward:false,historyStack:[],forwardStack:[],historyIframe:null,bookmarkAnchor:null,locationTimer:null,setInitialState:function(args){
this.initialState=this._createState(this.initialHref,args,this.initialHash);
},addToHistory:function(args){
this.forwardStack=[];
var hash=null;
var url=null;
if(!this.historyIframe){
this.historyIframe=window.frames["djhistory"];
}
if(!this.bookmarkAnchor){
this.bookmarkAnchor=document.createElement("a");
dojo.body().appendChild(this.bookmarkAnchor);
this.bookmarkAnchor.style.display="none";
}
if(args["changeUrl"]){
hash="#"+((args["changeUrl"]!==true)?args["changeUrl"]:(new Date()).getTime());
if(this.historyStack.length==0&&this.initialState.urlHash==hash){
this.initialState=this._createState(url,args,hash);
return;
}else{
if(this.historyStack.length>0&&this.historyStack[this.historyStack.length-1].urlHash==hash){
this.historyStack[this.historyStack.length-1]=this._createState(url,args,hash);
return;
}
}
this.changingUrl=true;
setTimeout("window.location.href = '"+hash+"'; dojo.undo.browser.changingUrl = false;",1);
this.bookmarkAnchor.href=hash;
if(dojo.render.html.ie){
url=this._loadIframeHistory();
var _317=args["back"]||args["backButton"]||args["handle"];
var tcb=function(_319){
if(window.location.hash!=""){
setTimeout("window.location.href = '"+hash+"';",1);
}
_317.apply(this,[_319]);
};
if(args["back"]){
args.back=tcb;
}else{
if(args["backButton"]){
args.backButton=tcb;
}else{
if(args["handle"]){
args.handle=tcb;
}
}
}
var _31a=args["forward"]||args["forwardButton"]||args["handle"];
var tfw=function(_31c){
if(window.location.hash!=""){
window.location.href=hash;
}
if(_31a){
_31a.apply(this,[_31c]);
}
};
if(args["forward"]){
args.forward=tfw;
}else{
if(args["forwardButton"]){
args.forwardButton=tfw;
}else{
if(args["handle"]){
args.handle=tfw;
}
}
}
}else{
if(dojo.render.html.moz){
if(!this.locationTimer){
this.locationTimer=setInterval("dojo.undo.browser.checkLocation();",200);
}
}
}
}else{
url=this._loadIframeHistory();
}
this.historyStack.push(this._createState(url,args,hash));
},checkLocation:function(){
if(!this.changingUrl){
var hsl=this.historyStack.length;
if((window.location.hash==this.initialHash||window.location.href==this.initialHref)&&(hsl==1)){
this.handleBackButton();
return;
}
if(this.forwardStack.length>0){
if(this.forwardStack[this.forwardStack.length-1].urlHash==window.location.hash){
this.handleForwardButton();
return;
}
}
if((hsl>=2)&&(this.historyStack[hsl-2])){
if(this.historyStack[hsl-2].urlHash==window.location.hash){
this.handleBackButton();
return;
}
}
}
},iframeLoaded:function(evt,_31f){
if(!dojo.render.html.opera){
var _320=this._getUrlQuery(_31f.href);
if(_320==null){
if(this.historyStack.length==1){
this.handleBackButton();
}
return;
}
if(this.moveForward){
this.moveForward=false;
return;
}
if(this.historyStack.length>=2&&_320==this._getUrlQuery(this.historyStack[this.historyStack.length-2].url)){
this.handleBackButton();
}else{
if(this.forwardStack.length>0&&_320==this._getUrlQuery(this.forwardStack[this.forwardStack.length-1].url)){
this.handleForwardButton();
}
}
}
},handleBackButton:function(){
var _321=this.historyStack.pop();
if(!_321){
return;
}
var last=this.historyStack[this.historyStack.length-1];
if(!last&&this.historyStack.length==0){
last=this.initialState;
}
if(last){
if(last.kwArgs["back"]){
last.kwArgs["back"]();
}else{
if(last.kwArgs["backButton"]){
last.kwArgs["backButton"]();
}else{
if(last.kwArgs["handle"]){
last.kwArgs.handle("back");
}
}
}
}
this.forwardStack.push(_321);
},handleForwardButton:function(){
var last=this.forwardStack.pop();
if(!last){
return;
}
if(last.kwArgs["forward"]){
last.kwArgs.forward();
}else{
if(last.kwArgs["forwardButton"]){
last.kwArgs.forwardButton();
}else{
if(last.kwArgs["handle"]){
last.kwArgs.handle("forward");
}
}
}
this.historyStack.push(last);
},_createState:function(url,args,hash){
return {"url":url,"kwArgs":args,"urlHash":hash};
},_getUrlQuery:function(url){
var _328=url.split("?");
if(_328.length<2){
return null;
}else{
return _328[1];
}
},_loadIframeHistory:function(){
var url=dojo.hostenv.getBaseScriptUri()+"iframe_history.html?"+(new Date()).getTime();
this.moveForward=true;
dojo.io.setIFrameSrc(this.historyIframe,url,false);
return url;
}};
dojo.provide("dojo.io.BrowserIO");
dojo.io.checkChildrenForFile=function(node){
var _32b=false;
var _32c=node.getElementsByTagName("input");
dojo.lang.forEach(_32c,function(_32d){
if(_32b){
return;
}
if(_32d.getAttribute("type")=="file"){
_32b=true;
}
});
return _32b;
};
dojo.io.formHasFile=function(_32e){
return dojo.io.checkChildrenForFile(_32e);
};
dojo.io.updateNode=function(node,_330){
node=dojo.byId(node);
var args=_330;
if(dojo.lang.isString(_330)){
args={url:_330};
}
args.mimetype="text/html";
args.load=function(t,d,e){
while(node.firstChild){
if(dojo["event"]){
try{
dojo.event.browser.clean(node.firstChild);
}
catch(e){
}
}
node.removeChild(node.firstChild);
}
node.innerHTML=d;
};
dojo.io.bind(args);
};
dojo.io.formFilter=function(node){
var type=(node.type||"").toLowerCase();
return !node.disabled&&node.name&&!dojo.lang.inArray(["file","submit","image","reset","button"],type);
};
dojo.io.encodeForm=function(_337,_338,_339){
if((!_337)||(!_337.tagName)||(!_337.tagName.toLowerCase()=="form")){
dojo.raise("Attempted to encode a non-form element.");
}
if(!_339){
_339=dojo.io.formFilter;
}
var enc=/utf/i.test(_338||"")?encodeURIComponent:dojo.string.encodeAscii;
var _33b=[];
for(var i=0;i<_337.elements.length;i++){
var elm=_337.elements[i];
if(!elm||elm.tagName.toLowerCase()=="fieldset"||!_339(elm)){
continue;
}
var name=enc(elm.name);
var type=elm.type.toLowerCase();
if(type=="select-multiple"){
for(var j=0;j<elm.options.length;j++){
if(elm.options[j].selected){
_33b.push(name+"="+enc(elm.options[j].value));
}
}
}else{
if(dojo.lang.inArray(["radio","checkbox"],type)){
if(elm.checked){
_33b.push(name+"="+enc(elm.value));
}
}else{
_33b.push(name+"="+enc(elm.value));
}
}
}
var _341=_337.getElementsByTagName("input");
for(var i=0;i<_341.length;i++){
var _342=_341[i];
if(_342.type.toLowerCase()=="image"&&_342.form==_337&&_339(_342)){
var name=enc(_342.name);
_33b.push(name+"="+enc(_342.value));
_33b.push(name+".x=0");
_33b.push(name+".y=0");
}
}
return _33b.join("&")+"&";
};
dojo.io.FormBind=function(args){
this.bindArgs={};
if(args&&args.formNode){
this.init(args);
}else{
if(args){
this.init({formNode:args});
}
}
};
dojo.lang.extend(dojo.io.FormBind,{form:null,bindArgs:null,clickedButton:null,init:function(args){
var form=dojo.byId(args.formNode);
if(!form||!form.tagName||form.tagName.toLowerCase()!="form"){
throw new Error("FormBind: Couldn't apply, invalid form");
}else{
if(this.form==form){
return;
}else{
if(this.form){
throw new Error("FormBind: Already applied to a form");
}
}
}
dojo.lang.mixin(this.bindArgs,args);
this.form=form;
this.connect(form,"onsubmit","submit");
for(var i=0;i<form.elements.length;i++){
var node=form.elements[i];
if(node&&node.type&&dojo.lang.inArray(["submit","button"],node.type.toLowerCase())){
this.connect(node,"onclick","click");
}
}
var _348=form.getElementsByTagName("input");
for(var i=0;i<_348.length;i++){
var _349=_348[i];
if(_349.type.toLowerCase()=="image"&&_349.form==form){
this.connect(_349,"onclick","click");
}
}
},onSubmit:function(form){
return true;
},submit:function(e){
e.preventDefault();
if(this.onSubmit(this.form)){
dojo.io.bind(dojo.lang.mixin(this.bindArgs,{formFilter:dojo.lang.hitch(this,"formFilter")}));
}
},click:function(e){
var node=e.currentTarget;
if(node.disabled){
return;
}
this.clickedButton=node;
},formFilter:function(node){
var type=(node.type||"").toLowerCase();
var _350=false;
if(node.disabled||!node.name){
_350=false;
}else{
if(dojo.lang.inArray(["submit","button","image"],type)){
if(!this.clickedButton){
this.clickedButton=node;
}
_350=node==this.clickedButton;
}else{
_350=!dojo.lang.inArray(["file","submit","reset","button"],type);
}
}
return _350;
},connect:function(_351,_352,_353){
if(dojo.evalObjPath("dojo.event.connect")){
dojo.event.connect(_351,_352,this,_353);
}else{
var fcn=dojo.lang.hitch(this,_353);
_351[_352]=function(e){
if(!e){
e=window.event;
}
if(!e.currentTarget){
e.currentTarget=e.srcElement;
}
if(!e.preventDefault){
e.preventDefault=function(){
window.event.returnValue=false;
};
}
fcn(e);
};
}
}});
dojo.io.XMLHTTPTransport=new function(){
var _356=this;
var _357={};
this.useCache=false;
this.preventCache=false;
function getCacheKey(url,_359,_35a){
return url+"|"+_359+"|"+_35a.toLowerCase();
}
function addToCache(url,_35c,_35d,http){
_357[getCacheKey(url,_35c,_35d)]=http;
}
function getFromCache(url,_360,_361){
return _357[getCacheKey(url,_360,_361)];
}
this.clearCache=function(){
_357={};
};
function doLoad(_362,http,url,_365,_366){
if(((http.status>=200)&&(http.status<300))||(http.status==304)||(location.protocol=="file:"&&(http.status==0||http.status==undefined))||(location.protocol=="chrome:"&&(http.status==0||http.status==undefined))){
var ret;
if(_362.method.toLowerCase()=="head"){
var _368=http.getAllResponseHeaders();
ret={};
ret.toString=function(){
return _368;
};
var _369=_368.split(/[\r\n]+/g);
for(var i=0;i<_369.length;i++){
var pair=_369[i].match(/^([^:]+)\s*:\s*(.+)$/i);
if(pair){
ret[pair[1]]=pair[2];
}
}
}else{
if(_362.mimetype=="text/javascript"){
try{
ret=dj_eval(http.responseText);
}
catch(e){
dojo.debug(e);
dojo.debug(http.responseText);
ret=null;
}
}else{
if(_362.mimetype=="text/json"||_362.mimetype=="application/json"){
try{
ret=dj_eval("("+http.responseText+")");
}
catch(e){
dojo.debug(e);
dojo.debug(http.responseText);
ret=false;
}
}else{
if((_362.mimetype=="application/xml")||(_362.mimetype=="text/xml")){
ret=http.responseXML;
if(!ret||typeof ret=="string"||!http.getResponseHeader("Content-Type")){
ret=dojo.dom.createDocumentFromText(http.responseText);
}
}else{
ret=http.responseText;
}
}
}
}
if(_366){
addToCache(url,_365,_362.method,http);
}
_362[(typeof _362.load=="function")?"load":"handle"]("load",ret,http,_362);
}else{
var _36c=new dojo.io.Error("XMLHttpTransport Error: "+http.status+" "+http.statusText);
_362[(typeof _362.error=="function")?"error":"handle"]("error",_36c,http,_362);
}
}
function setHeaders(http,_36e){
if(_36e["headers"]){
for(var _36f in _36e["headers"]){
if(_36f.toLowerCase()=="content-type"&&!_36e["contentType"]){
_36e["contentType"]=_36e["headers"][_36f];
}else{
http.setRequestHeader(_36f,_36e["headers"][_36f]);
}
}
}
}
this.inFlight=[];
this.inFlightTimer=null;
this.startWatchingInFlight=function(){
if(!this.inFlightTimer){
this.inFlightTimer=setTimeout("dojo.io.XMLHTTPTransport.watchInFlight();",10);
}
};
this.watchInFlight=function(){
var now=null;
if(!dojo.hostenv._blockAsync&&!_356._blockAsync){
for(var x=this.inFlight.length-1;x>=0;x--){
try{
var tif=this.inFlight[x];
if(!tif||tif.http._aborted||!tif.http.readyState){
this.inFlight.splice(x,1);
continue;
}
if(4==tif.http.readyState){
this.inFlight.splice(x,1);
doLoad(tif.req,tif.http,tif.url,tif.query,tif.useCache);
}else{
if(tif.startTime){
if(!now){
now=(new Date()).getTime();
}
if(tif.startTime+(tif.req.timeoutSeconds*1000)<now){
if(typeof tif.http.abort=="function"){
tif.http.abort();
}
this.inFlight.splice(x,1);
tif.req[(typeof tif.req.timeout=="function")?"timeout":"handle"]("timeout",null,tif.http,tif.req);
}
}
}
}
catch(e){
try{
var _373=new dojo.io.Error("XMLHttpTransport.watchInFlight Error: "+e);
tif.req[(typeof tif.req.error=="function")?"error":"handle"]("error",_373,tif.http,tif.req);
}
catch(e2){
dojo.debug("XMLHttpTransport error callback failed: "+e2);
}
}
}
}
clearTimeout(this.inFlightTimer);
if(this.inFlight.length==0){
this.inFlightTimer=null;
return;
}
this.inFlightTimer=setTimeout("dojo.io.XMLHTTPTransport.watchInFlight();",10);
};
var _374=dojo.hostenv.getXmlhttpObject()?true:false;
this.canHandle=function(_375){
return _374&&dojo.lang.inArray(["text/plain","text/html","application/xml","text/xml","text/javascript","text/json","application/json"],(_375["mimetype"].toLowerCase()||""))&&!(_375["formNode"]&&dojo.io.formHasFile(_375["formNode"]));
};
this.multipartBoundary="45309FFF-BD65-4d50-99C9-36986896A96F";
this.bind=function(_376){
if(!_376["url"]){
if(!_376["formNode"]&&(_376["backButton"]||_376["back"]||_376["changeUrl"]||_376["watchForURL"])&&(!djConfig.preventBackButtonFix)){
dojo.deprecated("Using dojo.io.XMLHTTPTransport.bind() to add to browser history without doing an IO request","Use dojo.undo.browser.addToHistory() instead.","0.4");
dojo.undo.browser.addToHistory(_376);
return true;
}
}
var url=_376.url;
var _378="";
if(_376["formNode"]){
var ta=_376.formNode.getAttribute("action");
if((ta)&&(!_376["url"])){
url=ta;
}
var tp=_376.formNode.getAttribute("method");
if((tp)&&(!_376["method"])){
_376.method=tp;
}
_378+=dojo.io.encodeForm(_376.formNode,_376.encoding,_376["formFilter"]);
}
if(url.indexOf("#")>-1){
dojo.debug("Warning: dojo.io.bind: stripping hash values from url:",url);
url=url.split("#")[0];
}
if(_376["file"]){
_376.method="post";
}
if(!_376["method"]){
_376.method="get";
}
if(_376.method.toLowerCase()=="get"){
_376.multipart=false;
}else{
if(_376["file"]){
_376.multipart=true;
}else{
if(!_376["multipart"]){
_376.multipart=false;
}
}
}
if(_376["backButton"]||_376["back"]||_376["changeUrl"]){
dojo.undo.browser.addToHistory(_376);
}
var _37b=_376["content"]||{};
if(_376.sendTransport){
_37b["dojo.transport"]="xmlhttp";
}
do{
if(_376.postContent){
_378=_376.postContent;
break;
}
if(_37b){
_378+=dojo.io.argsFromMap(_37b,_376.encoding);
}
if(_376.method.toLowerCase()=="get"||!_376.multipart){
break;
}
var t=[];
if(_378.length){
var q=_378.split("&");
for(var i=0;i<q.length;++i){
if(q[i].length){
var p=q[i].split("=");
t.push("--"+this.multipartBoundary,"Content-Disposition: form-data; name=\""+p[0]+"\"","",p[1]);
}
}
}
if(_376.file){
if(dojo.lang.isArray(_376.file)){
for(var i=0;i<_376.file.length;++i){
var o=_376.file[i];
t.push("--"+this.multipartBoundary,"Content-Disposition: form-data; name=\""+o.name+"\"; filename=\""+("fileName" in o?o.fileName:o.name)+"\"","Content-Type: "+("contentType" in o?o.contentType:"application/octet-stream"),"",o.content);
}
}else{
var o=_376.file;
t.push("--"+this.multipartBoundary,"Content-Disposition: form-data; name=\""+o.name+"\"; filename=\""+("fileName" in o?o.fileName:o.name)+"\"","Content-Type: "+("contentType" in o?o.contentType:"application/octet-stream"),"",o.content);
}
}
if(t.length){
t.push("--"+this.multipartBoundary+"--","");
_378=t.join("\r\n");
}
}while(false);
var _381=_376["sync"]?false:true;
var _382=_376["preventCache"]||(this.preventCache==true&&_376["preventCache"]!=false);
var _383=_376["useCache"]==true||(this.useCache==true&&_376["useCache"]!=false);
if(!_382&&_383){
var _384=getFromCache(url,_378,_376.method);
if(_384){
doLoad(_376,_384,url,_378,false);
return;
}
}
var http=dojo.hostenv.getXmlhttpObject(_376);
var _386=false;
if(_381){
var _387=this.inFlight.push({"req":_376,"http":http,"url":url,"query":_378,"useCache":_383,"startTime":_376.timeoutSeconds?(new Date()).getTime():0});
this.startWatchingInFlight();
}else{
_356._blockAsync=true;
}
if(_376.method.toLowerCase()=="post"){
if(!_376.user){
http.open("POST",url,_381);
}else{
http.open("POST",url,_381,_376.user,_376.password);
}
setHeaders(http,_376);
http.setRequestHeader("Content-Type",_376.multipart?("multipart/form-data; boundary="+this.multipartBoundary):(_376.contentType||"application/x-www-form-urlencoded"));
try{
http.send(_378);
}
catch(e){
if(typeof http.abort=="function"){
http.abort();
}
doLoad(_376,{status:404},url,_378,_383);
}
}else{
var _388=url;
if(_378!=""){
_388+=(_388.indexOf("?")>-1?"&":"?")+_378;
}
if(_382){
_388+=(dojo.string.endsWithAny(_388,"?","&")?"":(_388.indexOf("?")>-1?"&":"?"))+"dojo.preventCache="+new Date().valueOf();
}
if(!_376.user){
http.open(_376.method.toUpperCase(),_388,_381);
}else{
http.open(_376.method.toUpperCase(),_388,_381,_376.user,_376.password);
}
setHeaders(http,_376);
try{
http.send(null);
}
catch(e){
if(typeof http.abort=="function"){
http.abort();
}
doLoad(_376,{status:404},url,_378,_383);
}
}
if(!_381){
doLoad(_376,http,url,_378,_383);
_356._blockAsync=false;
}
_376.abort=function(){
try{
http._aborted=true;
}
catch(e){
}
return http.abort();
};
return;
};
dojo.io.transports.addTransport("XMLHTTPTransport");
};
dojo.provide("dojo.io.cookie");
dojo.io.cookie.setCookie=function(name,_38a,days,path,_38d,_38e){
var _38f=-1;
if(typeof days=="number"&&days>=0){
var d=new Date();
d.setTime(d.getTime()+(days*24*60*60*1000));
_38f=d.toGMTString();
}
_38a=escape(_38a);
document.cookie=name+"="+_38a+";"+(_38f!=-1?" expires="+_38f+";":"")+(path?"path="+path:"")+(_38d?"; domain="+_38d:"")+(_38e?"; secure":"");
};
dojo.io.cookie.set=dojo.io.cookie.setCookie;
dojo.io.cookie.getCookie=function(name){
var idx=document.cookie.lastIndexOf(name+"=");
if(idx==-1){
return null;
}
var _393=document.cookie.substring(idx+name.length+1);
var end=_393.indexOf(";");
if(end==-1){
end=_393.length;
}
_393=_393.substring(0,end);
_393=unescape(_393);
return _393;
};
dojo.io.cookie.get=dojo.io.cookie.getCookie;
dojo.io.cookie.deleteCookie=function(name){
dojo.io.cookie.setCookie(name,"-",0);
};
dojo.io.cookie.setObjectCookie=function(name,obj,days,path,_39a,_39b,_39c){
if(arguments.length==5){
_39c=_39a;
_39a=null;
_39b=null;
}
var _39d=[],_39e,_39f="";
if(!_39c){
_39e=dojo.io.cookie.getObjectCookie(name);
}
if(days>=0){
if(!_39e){
_39e={};
}
for(var prop in obj){
if(prop==null){
delete _39e[prop];
}else{
if(typeof obj[prop]=="string"||typeof obj[prop]=="number"){
_39e[prop]=obj[prop];
}
}
}
prop=null;
for(var prop in _39e){
_39d.push(escape(prop)+"="+escape(_39e[prop]));
}
_39f=_39d.join("&");
}
dojo.io.cookie.setCookie(name,_39f,days,path,_39a,_39b);
};
dojo.io.cookie.getObjectCookie=function(name){
var _3a2=null,_3a3=dojo.io.cookie.getCookie(name);
if(_3a3){
_3a2={};
var _3a4=_3a3.split("&");
for(var i=0;i<_3a4.length;i++){
var pair=_3a4[i].split("=");
var _3a7=pair[1];
if(isNaN(_3a7)){
_3a7=unescape(pair[1]);
}
_3a2[unescape(pair[0])]=_3a7;
}
}
return _3a2;
};
dojo.io.cookie.isSupported=function(){
if(typeof navigator.cookieEnabled!="boolean"){
dojo.io.cookie.setCookie("__TestingYourBrowserForCookieSupport__","CookiesAllowed",90,null);
var _3a8=dojo.io.cookie.getCookie("__TestingYourBrowserForCookieSupport__");
navigator.cookieEnabled=(_3a8=="CookiesAllowed");
if(navigator.cookieEnabled){
this.deleteCookie("__TestingYourBrowserForCookieSupport__");
}
}
return navigator.cookieEnabled;
};
if(!dojo.io.cookies){
dojo.io.cookies=dojo.io.cookie;
}
dojo.provide("dojo.io.*");
dojo.provide("dojo.lang.type");
dojo.lang.whatAmI=function(_3a9){
dojo.deprecated("dojo.lang.whatAmI","use dojo.lang.getType instead","0.5");
return dojo.lang.getType(_3a9);
};
dojo.lang.whatAmI.custom={};
dojo.lang.getType=function(_3aa){
try{
if(dojo.lang.isArray(_3aa)){
return "array";
}
if(dojo.lang.isFunction(_3aa)){
return "function";
}
if(dojo.lang.isString(_3aa)){
return "string";
}
if(dojo.lang.isNumber(_3aa)){
return "number";
}
if(dojo.lang.isBoolean(_3aa)){
return "boolean";
}
if(dojo.lang.isAlien(_3aa)){
return "alien";
}
if(dojo.lang.isUndefined(_3aa)){
return "undefined";
}
for(var name in dojo.lang.whatAmI.custom){
if(dojo.lang.whatAmI.custom[name](_3aa)){
return name;
}
}
if(dojo.lang.isObject(_3aa)){
return "object";
}
}
catch(e){
}
return "unknown";
};
dojo.lang.isNumeric=function(_3ac){
return (!isNaN(_3ac)&&isFinite(_3ac)&&(_3ac!=null)&&!dojo.lang.isBoolean(_3ac)&&!dojo.lang.isArray(_3ac)&&!/^\s*$/.test(_3ac));
};
dojo.lang.isBuiltIn=function(_3ad){
return (dojo.lang.isArray(_3ad)||dojo.lang.isFunction(_3ad)||dojo.lang.isString(_3ad)||dojo.lang.isNumber(_3ad)||dojo.lang.isBoolean(_3ad)||(_3ad==null)||(_3ad instanceof Error)||(typeof _3ad=="error"));
};
dojo.lang.isPureObject=function(_3ae){
return ((_3ae!=null)&&dojo.lang.isObject(_3ae)&&_3ae.constructor==Object);
};
dojo.lang.isOfType=function(_3af,type,_3b1){
var _3b2=false;
if(_3b1){
_3b2=_3b1["optional"];
}
if(_3b2&&((_3af===null)||dojo.lang.isUndefined(_3af))){
return true;
}
if(dojo.lang.isArray(type)){
var _3b3=type;
for(var i in _3b3){
var _3b5=_3b3[i];
if(dojo.lang.isOfType(_3af,_3b5)){
return true;
}
}
return false;
}else{
if(dojo.lang.isString(type)){
type=type.toLowerCase();
}
switch(type){
case Array:
case "array":
return dojo.lang.isArray(_3af);
case Function:
case "function":
return dojo.lang.isFunction(_3af);
case String:
case "string":
return dojo.lang.isString(_3af);
case Number:
case "number":
return dojo.lang.isNumber(_3af);
case "numeric":
return dojo.lang.isNumeric(_3af);
case Boolean:
case "boolean":
return dojo.lang.isBoolean(_3af);
case Object:
case "object":
return dojo.lang.isObject(_3af);
case "pureobject":
return dojo.lang.isPureObject(_3af);
case "builtin":
return dojo.lang.isBuiltIn(_3af);
case "alien":
return dojo.lang.isAlien(_3af);
case "undefined":
return dojo.lang.isUndefined(_3af);
case null:
case "null":
return (_3af===null);
case "optional":
dojo.deprecated("dojo.lang.isOfType(value, [type, \"optional\"])","use dojo.lang.isOfType(value, type, {optional: true} ) instead","0.5");
return ((_3af===null)||dojo.lang.isUndefined(_3af));
default:
if(dojo.lang.isFunction(type)){
return (_3af instanceof type);
}else{
dojo.raise("dojo.lang.isOfType() was passed an invalid type");
}
}
}
dojo.raise("If we get here, it means a bug was introduced above.");
};
dojo.lang.getObject=function(str){
var _3b7=str.split("."),i=0,obj=dj_global;
do{
obj=obj[_3b7[i++]];
}while(i<_3b7.length&&obj);
return (obj!=dj_global)?obj:null;
};
dojo.lang.doesObjectExist=function(str){
var _3bb=str.split("."),i=0,obj=dj_global;
do{
obj=obj[_3bb[i++]];
}while(i<_3bb.length&&obj);
return (obj&&obj!=dj_global);
};
dojo.provide("dojo.lang.assert");
dojo.lang.assert=function(_3be,_3bf){
if(!_3be){
var _3c0="An assert statement failed.\n"+"The method dojo.lang.assert() was called with a 'false' value.\n";
if(_3bf){
_3c0+="Here's the assert message:\n"+_3bf+"\n";
}
throw new Error(_3c0);
}
};
dojo.lang.assertType=function(_3c1,type,_3c3){
if(dojo.lang.isString(_3c3)){
dojo.deprecated("dojo.lang.assertType(value, type, \"message\")","use dojo.lang.assertType(value, type) instead","0.5");
}
if(!dojo.lang.isOfType(_3c1,type,_3c3)){
if(!dojo.lang.assertType._errorMessage){
dojo.lang.assertType._errorMessage="Type mismatch: dojo.lang.assertType() failed.";
}
dojo.lang.assert(false,dojo.lang.assertType._errorMessage);
}
};
dojo.lang.assertValidKeywords=function(_3c4,_3c5,_3c6){
var key;
if(!_3c6){
if(!dojo.lang.assertValidKeywords._errorMessage){
dojo.lang.assertValidKeywords._errorMessage="In dojo.lang.assertValidKeywords(), found invalid keyword:";
}
_3c6=dojo.lang.assertValidKeywords._errorMessage;
}
if(dojo.lang.isArray(_3c5)){
for(key in _3c4){
if(!dojo.lang.inArray(_3c5,key)){
dojo.lang.assert(false,_3c6+" "+key);
}
}
}else{
for(key in _3c4){
if(!(key in _3c5)){
dojo.lang.assert(false,_3c6+" "+key);
}
}
}
};
dojo.provide("dojo.AdapterRegistry");
dojo.AdapterRegistry=function(_3c8){
this.pairs=[];
this.returnWrappers=_3c8||false;
};
dojo.lang.extend(dojo.AdapterRegistry,{register:function(name,_3ca,wrap,_3cc,_3cd){
var type=(_3cd)?"unshift":"push";
this.pairs[type]([name,_3ca,wrap,_3cc]);
},match:function(){
for(var i=0;i<this.pairs.length;i++){
var pair=this.pairs[i];
if(pair[1].apply(this,arguments)){
if((pair[3])||(this.returnWrappers)){
return pair[2];
}else{
return pair[2].apply(this,arguments);
}
}
}
throw new Error("No match found");
},unregister:function(name){
for(var i=0;i<this.pairs.length;i++){
var pair=this.pairs[i];
if(pair[0]==name){
this.pairs.splice(i,1);
return true;
}
}
return false;
}});
dojo.provide("dojo.lang.repr");
dojo.lang.reprRegistry=new dojo.AdapterRegistry();
dojo.lang.registerRepr=function(name,_3d5,wrap,_3d7){
dojo.lang.reprRegistry.register(name,_3d5,wrap,_3d7);
};
dojo.lang.repr=function(obj){
if(typeof (obj)=="undefined"){
return "undefined";
}else{
if(obj===null){
return "null";
}
}
try{
if(typeof (obj["__repr__"])=="function"){
return obj["__repr__"]();
}else{
if((typeof (obj["repr"])=="function")&&(obj.repr!=arguments.callee)){
return obj["repr"]();
}
}
return dojo.lang.reprRegistry.match(obj);
}
catch(e){
if(typeof (obj.NAME)=="string"&&(obj.toString==Function.prototype.toString||obj.toString==Object.prototype.toString)){
return obj.NAME;
}
}
if(typeof (obj)=="function"){
obj=(obj+"").replace(/^\s+/,"");
var idx=obj.indexOf("{");
if(idx!=-1){
obj=obj.substr(0,idx)+"{...}";
}
}
return obj+"";
};
dojo.lang.reprArrayLike=function(arr){
try{
var na=dojo.lang.map(arr,dojo.lang.repr);
return "["+na.join(", ")+"]";
}
catch(e){
}
};
(function(){
var m=dojo.lang;
m.registerRepr("arrayLike",m.isArrayLike,m.reprArrayLike);
m.registerRepr("string",m.isString,m.reprString);
m.registerRepr("numbers",m.isNumber,m.reprNumber);
m.registerRepr("boolean",m.isBoolean,m.reprNumber);
})();
dojo.provide("dojo.lang.declare");
dojo.lang.declare=function(_3dd,_3de,init,_3e0){
if((dojo.lang.isFunction(_3e0))||((!_3e0)&&(!dojo.lang.isFunction(init)))){
var temp=_3e0;
_3e0=init;
init=temp;
}
var _3e2=[];
if(dojo.lang.isArray(_3de)){
_3e2=_3de;
_3de=_3e2.shift();
}
if(!init){
init=dojo.evalObjPath(_3dd,false);
if((init)&&(!dojo.lang.isFunction(init))){
init=null;
}
}
var ctor=dojo.lang.declare._makeConstructor();
var scp=(_3de?_3de.prototype:null);
if(scp){
scp.prototyping=true;
ctor.prototype=new _3de();
scp.prototyping=false;
}
ctor.superclass=scp;
ctor.mixins=_3e2;
for(var i=0,l=_3e2.length;i<l;i++){
dojo.lang.extend(ctor,_3e2[i].prototype);
}
ctor.prototype.initializer=null;
ctor.prototype.declaredClass=_3dd;
if(dojo.lang.isArray(_3e0)){
dojo.lang.extend.apply(dojo.lang,[ctor].concat(_3e0));
}else{
dojo.lang.extend(ctor,(_3e0)||{});
}
dojo.lang.extend(ctor,dojo.lang.declare._common);
ctor.prototype.constructor=ctor;
ctor.prototype.initializer=(ctor.prototype.initializer)||(init)||(function(){
});
dojo.lang.setObjPathValue(_3dd,ctor,null,true);
return ctor;
};
dojo.lang.declare._makeConstructor=function(){
return function(){
var self=this._getPropContext();
var s=self.constructor.superclass;
if((s)&&(s.constructor)){
if(s.constructor==arguments.callee){
this._inherited("constructor",arguments);
}else{
this._contextMethod(s,"constructor",arguments);
}
}
var ms=(self.constructor.mixins)||([]);
for(var i=0,m;(m=ms[i]);i++){
(((m.prototype)&&(m.prototype.initializer))||(m)).apply(this,arguments);
}
if((!this.prototyping)&&(self.initializer)){
self.initializer.apply(this,arguments);
}
};
};
dojo.lang.declare._common={_getPropContext:function(){
return (this.___proto||this);
},_contextMethod:function(_3ec,_3ed,args){
var _3ef,_3f0=this.___proto;
this.___proto=_3ec;
try{
_3ef=_3ec[_3ed].apply(this,(args||[]));
}
catch(e){
throw e;
}
finally{
this.___proto=_3f0;
}
return _3ef;
},_inherited:function(prop,args){
var p=this._getPropContext();
do{
if((!p.constructor)||(!p.constructor.superclass)){
return;
}
p=p.constructor.superclass;
}while(!(prop in p));
return (dojo.lang.isFunction(p[prop])?this._contextMethod(p,prop,args):p[prop]);
}};
dojo.declare=dojo.lang.declare;
dojo.provide("dojo.lang.*");
dojo.provide("dojo.storage");
dojo.storage.StorageProvider={};
dojo.declare("dojo.storage",null,{SUCCESS:"success",FAILED:"failed",PENDING:"pending",SIZE_NOT_AVAILABLE:"Size not available",SIZE_NO_LIMIT:"No size limit","namespace":"dojoStorage",onHideSettingsUI:null,initialize:function(){
dojo.unimplemented("dojo.storage.initialize");
},isAvailable:function(){
dojo.unimplemented("dojo.storage.isAvailable");
},put:function(key,_3f5,_3f6){
dojo.unimplemented("dojo.storage.put");
},get:function(key){
dojo.unimplemented("dojo.storage.get");
},hasKey:function(key){
return (this.get(key)!=null);
},clear:function(){
dojo.unimplemented("dojo.storage.clear");
},remove:function(key){
dojo.unimplemented("dojo.storage.remove");
},isPermanent:function(){
dojo.unimplemented("dojo.storage.isPermanent");
},getMaximumSize:function(){
dojo.unimplemented("dojo.storage.getMaximumSize");
},hasSettingsUI:function(){
return false;
},showSettingsUI:function(){
dojo.unimplemented("dojo.storage.showSettingsUI");
},hideSettingsUI:function(){
dojo.unimplemented("dojo.storage.hideSettingsUI");
},getType:function(){
dojo.unimplemented("dojo.storage.getType");
},isValidKey:function(_3fa){
if((_3fa==null)||(typeof _3fa=="undefined")){
return false;
}
return /^[0-9A-Za-z_]*$/.test(_3fa);
}});
dojo.storage.manager=new function(){
this.currentProvider=null;
this.available=false;
this.initialized=false;
this.providers=[];
this["namespace"]="dojo.storage";
this.initialize=function(){
this.autodetect();
};
this.register=function(name,_3fc){
this.providers[this.providers.length]=_3fc;
this.providers[name]=_3fc;
};
this.setProvider=function(_3fd){
};
this.autodetect=function(){
if(this.initialized==true){
return;
}
var _3fe=null;
for(var i=0;i<this.providers.length;i++){
_3fe=this.providers[i];
if(_3fe.isAvailable()){
break;
}
}
if(_3fe==null){
this.initialized=true;
this.available=false;
this.currentProvider=null;
dojo.raise("No storage provider found for this platform");
}
this.currentProvider=_3fe;
for(var i in _3fe){
dojo.storage[i]=_3fe[i];
}
dojo.storage.manager=this;
dojo.storage.initialize();
this.initialized=true;
this.available=true;
};
this.isAvailable=function(){
return this.available;
};
this.isInitialized=function(){
if(dojo.flash.ready==false){
return false;
}else{
return this.initialized;
}
};
this.supportsProvider=function(_400){
try{
var _401=eval("new "+_400+"()");
var _402=_401.isAvailable();
if(_402==null||typeof _402=="undefined"){
return false;
}
return _402;
}
catch(exception){
dojo.debug("exception="+exception);
return false;
}
};
this.getProvider=function(){
return this.currentProvider;
};
this.loaded=function(){
};
};
dojo.provide("dojo.json");
dojo.json={jsonRegistry:new dojo.AdapterRegistry(),register:function(name,_404,wrap,_406){
dojo.json.jsonRegistry.register(name,_404,wrap,_406);
},evalJson:function(json){
try{
return eval("("+json+")");
}
catch(e){
dojo.debug(e);
return json;
}
},serialize:function(o){
var _409=typeof (o);
if(_409=="undefined"){
return "undefined";
}else{
if((_409=="number")||(_409=="boolean")){
return o+"";
}else{
if(o===null){
return "null";
}
}
}
if(_409=="string"){
return dojo.string.escapeString(o);
}
var me=arguments.callee;
var _40b;
if(typeof (o.__json__)=="function"){
_40b=o.__json__();
if(o!==_40b){
return me(_40b);
}
}
if(typeof (o.json)=="function"){
_40b=o.json();
if(o!==_40b){
return me(_40b);
}
}
if(_409!="function"&&typeof (o.length)=="number"){
var res=[];
for(var i=0;i<o.length;i++){
var val=me(o[i]);
if(typeof (val)!="string"){
val="undefined";
}
res.push(val);
}
return "["+res.join(",")+"]";
}
try{
window.o=o;
_40b=dojo.json.jsonRegistry.match(o);
return me(_40b);
}
catch(e){
}
if(_409=="function"){
return null;
}
res=[];
for(var k in o){
var _410;
if(typeof (k)=="number"){
_410="\""+k+"\"";
}else{
if(typeof (k)=="string"){
_410=dojo.string.escapeString(k);
}else{
continue;
}
}
val=me(o[k]);
if(typeof (val)!="string"){
continue;
}
res.push(_410+":"+val);
}
return "{"+res.join(",")+"}";
}};
dojo.provide("dojo.storage.dashboard");
dojo.storage.dashboard.StorageProvider=function(){
this.initialized=false;
};
dojo.inherits(dojo.storage.dashboard.StorageProvider,dojo.storage.StorageProvider);
dojo.lang.extend(dojo.storage.dashboard.StorageProvider,{storageOnLoad:function(){
this.initialized=true;
},set:function(key,_412,ns){
if(ns&&widget.system){
widget.system("/bin/mkdir "+ns);
var _414=widget.system("/bin/echo "+_412+" >"+ns+"/"+key);
if(_414.errorString){
return false;
}
return true;
}
return widget.setPreferenceForKey(dojo.json.serialize(_412),key);
},get:function(key,ns){
if(ns&&widget.system){
var _417=widget.system("/bin/cat "+ns+"/"+key);
if(_417.errorString){
return "";
}
return _417.outputString;
}
return dojo.json.evalJson(widget.preferenceForKey(key));
}});
dojo.storage.setProvider(new dojo.storage.dashboard.StorageProvider());
dojo.provide("dojo.storage.*");

